package pe.siso.dao;

import pe.siso.mysqldao.MySqlDAOFactory;

public abstract class DAOFactory {

    public static final int MYSQL = 1;
    public static final int ORACLE = 2;
    public static final int DB2 = 3;
    public static final int SQLSERVER = 4;
    public static final int XML = 5;

    public static DAOFactory getDAOFactory(int whichFactory) {
        switch (whichFactory) {
            case MYSQL:
                return new MySqlDAOFactory();
//            case SQLSERVER:
//                return new SqlServerDAOFactory();
            /*case ORACLE:
	       	    return new OracleDAOFactory();
	       	case DB2:
	       	    return new Db2DAOFactory();
	       	case SQLSERVER:
	       	    return new SqlServerDAOFactory();
	       	case XML:
	       	    return new XmlDAOFactory();*/
            default:
                return null;
        }
    }

    public abstract UbigeoDAO getUbigeoDAO();
    public abstract MenuDAO getMenuDAO();
    public abstract UsuarioDAO getUsuarioDAO();
    public abstract PeriodoDAO getPeriodoDAO();
    public abstract AlumnoDAO getAlumnoDAO();
    public abstract ApoderadoDAO getApoderadoDAO();
    public abstract EnfermedadDAO getEnfermedadDAO();
    public abstract MatriculaDAO getMatriculaDAO();
    public abstract AulaDAO getAulaDAO();
    public abstract LocalDAO getLocalDAO();
    public abstract PensionDAO getPensionDAO(); 
    public abstract DescuentoDAO getDescuentoDAO();
    public abstract RequisitoDAO getRequisitoDAO();
    public abstract ColegioDAO getColegioDAO();
    public abstract AlumnoHermanoDAO getAlumnoHermanoDAO();
    public abstract CuotasPagoDAO getCuotasPagoDAO();
    public abstract SeguroDAO getSeguroDAO();
}
