package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.beans.AlumnoBean;
import pe.siso.dao.AlumnoDAO;

public class MySqlAlumnoDAO implements AlumnoDAO {

    @Override
    public ArrayList<AlumnoBean> listaAlumno(String tipoDocumento, String busqueda, String periodo, int inicio, int cantidad) throws Exception {
        ArrayList<AlumnoBean> lista = new ArrayList<>();
        String filtros = "";
        if (tipoDocumento.equals("3")) {
            filtros = " CONCAT(ape_pat_alu,' ',ape_mat_alu) like '%" + busqueda + "%' ";
        } else if (tipoDocumento.equals("4")) {
            filtros = " a.cod_alu in (" + busqueda + ")";
        } else {
            filtros = " a.tip_doc=" + tipoDocumento + " and a.dni_alu=" + busqueda + " ";
        }

        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT\n"
                + "cod_alu, cod_alu_mat, dni_alu, nom_alu, ape_pat_alu, ape_mat_alu, fec_nac_alu, sex_alu, dir_alu, dir_ref_alu, cod_ubi, tel_alu, cel_alu, tel_eme_alu, viv_con_alu, usu_ins, fec_ins, usu_act, fec_act,tip_doc,correo_alu,vivienda_alu,preguntar_alu,\n"
                + "	CONCAT(a.ape_pat_alu,' ',a.ape_mat_alu,' ',a.nom_alu) nombreCompleto,\n"
                + "	a.cod_ban_alu,\n"
                + "DATE_FORMAT(a.fec_nac_alu,'%d/%m/%Y') fechaNacimiento,\n"
                + "	est_alu,\n"
                + "CASE WHEN (SELECT\n"
                + "					fm.cod_alu\n"
                + "				FROM\n"
                + "					ficha_matricula fm\n"
                + "				INNER JOIN periodo p ON p.cod_per = fm.cod_per\n"
                + "				WHERE\n"
                + "					fm.cod_alu = a.cod_alu\n"
                + "				AND p.cod_per = " + periodo + "  \n"
                + "				LIMIT 1\n"
                + "				) IS NULL THEN 0 ELSE 1 end  'est_mat',\n"
                + "				(select cod_grupo from alumno_hermano WHERE cod_alu=a.cod_alu ) 'cod_grupo'  \n"
                + "FROM\n"
                + "	alumno a WHERE 1=1 and " + filtros + "\n"
                + "ORDER BY\n"
                + "	a.cod_alu DESC\n"
                + "LIMIT " + inicio + ",\n"
                + " " + cantidad + ";";
        ResultSet rs = st.executeQuery(query);
        System.out.println("ListaAlumno ->>>>>>>>>>>>>>>>>>>>>>> " + query);
        //            correo_alu,vivienda_alu,preguntar_alu
        while (rs.next()) {
            AlumnoBean a = new AlumnoBean();
            a.setCodigo(rs.getInt("cod_alu"));
            a.setTxtApaterno(rs.getString("ape_pat_alu"));
            a.setTxtAmaterno(rs.getString("ape_mat_alu"));
            a.setTxtNombre(rs.getString("nom_alu"));
            a.setCodigoBanco(rs.getString("cod_ban_alu"));
            a.setTxtDni(rs.getString("dni_alu"));
            a.setSltDireccion(rs.getString("dir_alu"));
            try {
                a.setDatFecha(rs.getString("fec_nac_alu"));
            } catch (Exception e) {
                a.setDatFecha("");
            }
            a.setFechaNacimiento(rs.getString("fechaNacimiento"));
            a.setSltReferencia(rs.getString("dir_ref_alu"));
            a.setSltEmergencia(rs.getString("tel_eme_alu"));
            a.setSltVivecon(rs.getString("viv_con_alu"));
            a.setEstadoAlumno(rs.getString("est_alu"));
            a.setEstadoMatricula(rs.getString("est_mat"));
            a.setSlTipoDocumento(rs.getString("tip_doc"));
            a.setCodGrupo(rs.getInt("cod_grupo"));
            a.setSltSexo(rs.getString("sex_alu"));
            a.setNombreCompleto(rs.getString("nombreCompleto"));
            a.setCodigoUbigeo(rs.getInt("cod_ubi"));
            a.setSltTelefono(rs.getString("tel_alu"));
            a.setTxtCorreo(rs.getString("correo_alu"));
            a.setSltVivepropia(rs.getString("vivienda_alu"));
            a.setSltPreguntar(rs.getString("preguntar_alu"));
            lista.add(a);
        }
        return lista;
    }

    @Override
    public int CantlistaAlumno(String tipoDocumento, String busqueda, String periodo) throws Exception {
        int cantidad = 0;
        String filtros = "";
        if (tipoDocumento.equals("3")) {
            filtros = " CONCAT(ape_pat_alu,' ',ape_mat_alu) like '%" + busqueda + "%' ";
        } else {
            filtros = " a.tip_doc=" + tipoDocumento + " and a.dni_alu=" + busqueda + " ";
        }
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT\n"
                + "COUNT(1) cantidad\n"
                + "FROM\n"
                + "	alumno a WHERE 1=1 AND " + filtros + " ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            cantidad = rs.getInt("cantidad");
        }
        return cantidad;
    }

    @Override
    public String ListaHermanos(int codAlumno, int codGrupo) throws Exception {
        String codHermano = "";
        if (codGrupo == 0) {
            codHermano = codAlumno + "";
        } else {
            String base = "matricula";
            Connection cnx = MySqlDAOFactory.obtenerConexion(base);
            Statement st = cnx.createStatement();
            String query = "select GROUP_CONCAT(cod_alu) codhermano from alumno_hermano WHERE cod_grupo=" + codGrupo + " ;";
            System.out.println("");
            ResultSet rs = st.executeQuery(query);
            while (rs.next()) {
                codHermano = rs.getString("codHermano");
            }
        }

        return codHermano;
    }

    @Override
    public String registrarAlumno(ArrayList<AlumnoBean> alu) throws Exception {
        //----------------------------------------------------- INSERTAMOS EN MATRICULAS
        String codAlumno = null;
        int resultado = 0;
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        for (int i = 0; i < alu.size(); i++) {
            String query = "INSERT INTO alumno (cod_alu, cod_alu_mat, dni_alu, nom_alu, ape_pat_alu, ape_mat_alu, fec_nac_alu, sex_alu, cod_ban_alu, dir_alu, dir_ref_alu, cod_ubi, tel_alu, cel_alu, tel_eme_alu, viv_con_alu, usu_ins, fec_ins, usu_act, fec_act, est_alu,tip_doc,correo_alu,vivienda_alu,preguntar_alu) "
                    + "VALUES (null, '0', '" + alu.get(i).getTxtDni() + "', '" + alu.get(i).getTxtNombre() + "',"
                    + " '" + alu.get(i).getTxtApaterno() + "',"
                    + " '" + alu.get(i).getTxtAmaterno() + "',"
                    + " STR_TO_DATE('"+alu.get(i).getDatFecha()+"','%d/%m/%Y'),"
                    + " '" + alu.get(i).getSltSexo() + "',"
                    + " '0', '" + alu.get(i).getSltDireccion() + "',"
                    + " '" + alu.get(i).getSltReferencia() + "',"
                    + " " + alu.get(i).getSltDistrito() + ","
                    + " '" + alu.get(i).getSltTelefono() + "', '0',"
                    + " '" + alu.get(i).getSltEmergencia() + "',"
                    + " '" + alu.get(i).getSltVivecon() + "',"
                    + " " + alu.get(i).getCodUsuario() + ", now(), null, null,"
                    + " 1," + alu.get(i).getSlTipoDocumento() + " ,"
                    + " '" + alu.get(i).getTxtCorreo() + "',"
                    + " '" + alu.get(i).getSltVivepropia() + "',"
                    + " '" + alu.get(i).getSltPreguntar() + "' );";

            resultado = st.executeUpdate(query);
            System.out.println("INSERT ALUMNO (MATRICULAS) ----> " + query);
            ResultSet rs = st.getGeneratedKeys();
            if (rs.next()) {
                codAlumno = rs.getString(1);
            }
        }

        cnx.close();
        return codAlumno;

    }

    @Override
    public int registrarHermanos(ArrayList<AlumnoBean> hermano, Integer codGrupo, String codAlumno) throws Exception {
        int resultado = 0;
        String query = "";
        int maxGrupo = 0;
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        if (codGrupo == 0) { // los alumnos que no tiene grupo 
            query = "select MAX(cod_grupo)+1 maxgrupo from alumno_hermano";
            ResultSet rs = st.executeQuery(query);
            while (rs.next()) {
                codGrupo = rs.getInt("maxgrupo");
            }
            for (int i = 0; i < hermano.size(); i++) {
                query = "INSERT INTO  alumno_hermano   ( cod_alu_hno ,  cod_alu ,  cod_grupo ) VALUES (null, " + hermano.get(i).getCodigo() + ", " + codGrupo + ");";
                resultado = st.executeUpdate(query);
            }

        } else {// actualiza el grupo actual 
            for (int i = 0; i < hermano.size(); i++) {
                query = "update alumno_hermano  set cod_grupo=" + codGrupo + " WHERE cod_alu= " + hermano.get(i).getCodigo() + " ;";
                resultado = st.executeUpdate(query);
            }
        }
        query = "INSERT INTO  alumno_hermano   ( cod_alu_hno ,  cod_alu ,  cod_grupo ) VALUES (null, " + codAlumno + ", " + codGrupo + ");";
        resultado = st.executeUpdate(query);
        cnx.close();
        return resultado;

    }

    @Override
    public int actualizarAlumno(AlumnoBean alu) throws Exception {
        int resultado = 0;
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        String query = "UPDATE alumno SET dni_alu='" + alu.getTxtDni() + "', nom_alu='" + alu.getTxtNombre() + "', ape_pat_alu='" + alu.getTxtApaterno() + "', ape_mat_alu='" + alu.getTxtAmaterno() + "', fec_nac_alu='" + alu.getDatFecha() + "',"
                + " sex_alu='" + alu.getSltSexo() + "',  dir_alu='" + alu.getSltDireccion() + "', dir_ref_alu='" + alu.getSltReferencia() + "', cod_ubi=" + alu.getSltDistrito() + ", tel_alu='" + alu.getSltTelefono() + "', cel_alu='" + alu.getSltEmergencia() + "', tel_eme_alu='" + alu.getSltEmergencia() + "', viv_con_alu='" + alu.getSltVivecon() + "', "
                + "usu_act=" + alu.getCodUsuario() + ", fec_act=now(),tip_doc=" + alu.getSlTipoDocumento() + ",correo_alu='" + alu.getTxtCorreo() + "',vivienda_alu='" + alu.getSltVivepropia() + "',preguntar_alu='" + alu.getSltPreguntar() + "' WHERE cod_alu=" + alu.getCodigo() + " ;";

        System.out.println("UPDATE ALUMNO --->" + query);
        resultado = st.executeUpdate(query);
        System.out.println(resultado);

        cnx.close();
        return resultado;
    }

    @Override
    public int actualizarHermano(ArrayList<AlumnoBean> hermano, Integer codGrupo, String codAlumno) throws Exception {
        int resultado = 0;
        String Base = "matricula";
        String grupocodHermanos = codAlumno;
        String grupocodGrupo = codGrupo.toString();
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        Statement st1 = cnx.createStatement();
        String query = "";
        if (codGrupo == 0) {
            query = "select MAX(cod_grupo)+1 maxgrupo from alumno_hermano";
            ResultSet rs = st.executeQuery(query);
            while (rs.next()) {
                codGrupo = rs.getInt("maxgrupo");
            }
            query = "INSERT INTO alumno_hermano (cod_alu_hno, cod_alu, cod_grupo) VALUES (null, " + codAlumno + ", " + codGrupo + ") ;";
            st.executeUpdate(query);
        }
        for (int i = 0; i < hermano.size(); i++) {
            if (hermano.get(i).getCodGrupo() == 0) {
                grupocodHermanos += "," + hermano.get(i).getCodigo();
                query = "INSERT INTO alumno_hermano (cod_alu_hno, cod_alu, cod_grupo) VALUES (null, " + hermano.get(i).getCodigo() + ", " + codGrupo + ") ;";
                st.executeUpdate(query);
            } else {
                grupocodHermanos += "," + hermano.get(i).getCodigo();
                grupocodGrupo += "," + hermano.get(i).getCodGrupo();
            }
        }
        query = "select * from (\n"
                + "select ah.cod_alu_hno,ah.cod_alu,ah.cod_grupo,IF(IFNULL(x.cod_alu,0)=0,0,1) estado from alumno_hermano ah \n"
                + "LEFT JOIN (select cod_alu from alumno_hermano WHERE cod_alu in (" + grupocodHermanos + ") ) x on ah.cod_alu=x.cod_alu\n"
                + "WHERE ah.cod_grupo in (" + grupocodGrupo + ") \n"
                + ")c WHERE (c.cod_grupo<>" + codGrupo + " or c.estado<>1) ;";
        ResultSet rs1 = st.executeQuery(query);
        String queryApoderado = "";
        while (rs1.next()) {
            if (rs1.getInt("estado") == 0) {
                queryApoderado = "delete from alumno_hermano WHERE cod_alu_hno=" + rs1.getInt("cod_alu_hno") + " ;";
                st1.executeUpdate(queryApoderado);
            } else {
                queryApoderado = "update alumno_hermano set cod_grupo=" + codGrupo + " WHERE cod_alu_hno=" + rs1.getInt("cod_alu_hno") + " ;";
                st1.executeUpdate(queryApoderado);
            }
        }

        return resultado;
    }

    @Override
    public ArrayList<AlumnoBean> consultarHermanosAluOrdenadoPorEdad(int codGrupo, int anioPer, int codAlumno, String codLocal, String desLocal) throws Exception {
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        ArrayList<AlumnoBean> lista = new ArrayList<>();

        String query = "SELECT *  "
                + " FROM(SELECT ah.cod_alu_hno, ah.cod_alu, a.nom_alu, a.ape_pat_alu, a.ape_mat_alu, a.dni_alu, a.cod_ban_alu,  "
                + "		  YEAR(CURDATE())-YEAR(a.fec_nac_alu) + IF(DATE_FORMAT(CURDATE(),'%m-%d') > DATE_FORMAT(a.fec_nac_alu,'%m-%d'), 0, -1) AS edad "
                + "			,a.fec_nac_alu, ah.cod_grupo,au.cod_local, l.deslocal,fc.cod_local_dcto,fc.cod_mat "
                + " FROM alumno_hermano ah  "
                + " INNER JOIN alumno a on a.cod_alu=ah.cod_alu "
                + " INNER JOIN ficha_matricula fc on fc.cod_alu = a.cod_alu "
                + " INNER JOIN aula au on au.cod_aula = fc.cod_aula "
                + " INNER JOIN locales l on l.codlocal = au.cod_local "
                + " INNER JOIN periodo p on p.cod_per = fc.cod_per "
                + " WHERE cod_grupo=" + codGrupo + " and p.anio_per=" + anioPer
                + " UNION "
                + "SELECT ah.cod_alu_hno, ah.cod_alu, a.nom_alu, a.ape_pat_alu, a.ape_mat_alu, a.dni_alu, a.cod_ban_alu,  "
                + "		  YEAR(CURDATE())-YEAR(a.fec_nac_alu) + IF(DATE_FORMAT(CURDATE(),'%m-%d') > DATE_FORMAT(a.fec_nac_alu,'%m-%d'), 0, -1) AS edad "
                + "			,a.fec_nac_alu, ah.cod_grupo, '" + codLocal + "' as 'cod_local', '" + desLocal + "' as 'deslocal',0 ,'' "
                + " FROM alumno_hermano ah "
                + " INNER JOIN alumno a on a.cod_alu = ah.cod_alu "
                + " WHERE ah.cod_alu=" + codAlumno + ") x "
                + " ORDER BY x.fec_nac_alu ASC";

        System.out.println("consultarHermanosAluOrdenadoPorEdad ------>" + query);

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            AlumnoBean a = new AlumnoBean();
            a.setCodAlumnoHermano(rs.getInt("cod_alu_hno"));
            a.setCodigo(rs.getInt("cod_alu"));
            a.setTxtNombre(rs.getString("nom_alu"));
            a.setTxtApaterno(rs.getString("ape_pat_alu"));
            a.setTxtAmaterno(rs.getString("ape_mat_alu"));
            a.setTxtDni(rs.getString("dni_alu"));
            a.setCodigoBanco(rs.getString("cod_ban_alu"));
            a.setEdad(rs.getInt("edad"));
            a.setDatFecha(rs.getString("fec_nac_alu"));
            a.setCodGrupo(rs.getInt("cod_grupo"));
            a.setCodLocalMat(rs.getString("cod_local"));
            a.setDesLocalMat(rs.getString("deslocal"));
            a.setCodDescuentoLocal(rs.getInt("cod_local_dcto"));
            a.setCodMatricula(rs.getInt("cod_mat"));
            lista.add(a);
        }
        cnx.close();
        return lista;

    }

    @Override
    public AlumnoBean ConsultarAlumnoExitente(int codigoAlumno, int tipoDocumento, String documento, String nombreAlumno, String apellidoMaterno, String apelidoPaterno) throws Exception {
        AlumnoBean alumno = new AlumnoBean();
        String filtros = "";
        if (!documento.equals("")) {
            filtros += "AND dni_alu='" + documento + "' ";
        }
        if (!nombreAlumno.equals("")) {
            filtros += "AND nom_alu LIKE '%" + nombreAlumno + "%' ";
        }
        if (!apelidoPaterno.equals("")) {
            filtros += " AND ape_pat_alu='" + apelidoPaterno + "' ";
        }
        if (!apellidoMaterno.equals("")) {
            filtros += " AND ape_mat_alu='" + apellidoMaterno + "' ";
        }
        if (codigoAlumno != 0) {
            filtros += " AND cod_alu=" + codigoAlumno + " ";
        }
//        if (!documento.equals("") && !nombreAlumno.equals("") && !apelidoPaterno.equals("") && !apellidoMaterno.equals("") && codigoAlumno != 0) {
            String base = "matricula";
            Connection cnx = MySqlDAOFactory.obtenerConexion(base);
            Statement st = cnx.createStatement();
            String query = "SELECT \n"
                    + "     cod_alu, cod_alu_mat, dni_alu, nom_alu, ape_pat_alu, ape_mat_alu, fec_nac_alu, sex_alu, dir_alu, dir_ref_alu, cod_ubi, tel_alu, cel_alu, tel_eme_alu, viv_con_alu, usu_ins, fec_ins, usu_act, fec_act,tip_doc,correo_alu,vivienda_alu,preguntar_alu,\n"
                    + "	CONCAT(a.ape_pat_alu,' ',a.ape_mat_alu,' ',a.nom_alu) nombreCompleto,\n"
                    + "	a.cod_ban_alu,\n"
                    + "DATE_FORMAT(a.fec_nac_alu,'%d/%m/%Y') fechaNacimiento,\n"
                    + "	IF(est_alu=1,'<span class=\"label bg-success\">Activo</span>','<span class=\"label bg-danger\">Inactivo</span>')est_alu,\n"
                    + "				(select cod_grupo from alumno_hermano WHERE cod_alu=a.cod_alu ) 'cod_grupo'  \n"
                    + "FROM\n"
                    + "	alumno a WHERE 1=1  " + filtros + "\n"
                    + "ORDER BY\n"
                    + "	a.cod_alu DESC;";
            ResultSet rs = st.executeQuery(query);
            System.out.println("ConsultarAlumnoExitente ->>>>>>>>>>>>>>>>>>>>>>> " + query);
            //            correo_alu,vivienda_alu,preguntar_alu

            while (rs.next()) {
                alumno.setCodigo(rs.getInt("cod_alu"));
                alumno.setTxtApaterno(rs.getString("ape_pat_alu"));
                alumno.setTxtAmaterno(rs.getString("ape_mat_alu"));
                alumno.setTxtNombre(rs.getString("nom_alu"));
                alumno.setCodigoBanco(rs.getString("cod_ban_alu"));
                alumno.setTxtDni(rs.getString("dni_alu"));
                alumno.setSltDireccion(rs.getString("dir_alu"));
                try {
                    alumno.setDatFecha(rs.getString("fec_nac_alu"));
                } catch (Exception e) {
                    alumno.setDatFecha("");
                }
                alumno.setFechaNacimiento(rs.getString("fechaNacimiento"));
                alumno.setSltReferencia(rs.getString("dir_ref_alu"));
                alumno.setSltEmergencia(rs.getString("tel_eme_alu"));
                alumno.setSltVivecon(rs.getString("viv_con_alu"));
                alumno.setEstadoAlumno(rs.getString("est_alu"));
                alumno.setSlTipoDocumento(rs.getString("tip_doc"));
                alumno.setCodGrupo(rs.getInt("cod_grupo"));
                alumno.setSltSexo(rs.getString("sex_alu"));
                alumno.setNombreCompleto(rs.getString("nombreCompleto"));
                alumno.setCodigoUbigeo(rs.getInt("cod_ubi"));
                alumno.setSltTelefono(rs.getString("tel_alu"));
                alumno.setTxtCorreo(rs.getString("correo_alu"));
                alumno.setSltVivepropia(rs.getString("vivienda_alu"));
                alumno.setSltPreguntar(rs.getString("preguntar_alu"));
            }
//        }

        return alumno;
    }

}
