package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.DriverManager;
import pe.siso.dao.AlumnoDAO;
import pe.siso.dao.AlumnoHermanoDAO;
import pe.siso.dao.ApoderadoDAO;
import pe.siso.dao.AulaDAO;
import pe.siso.dao.ColegioDAO;
import pe.siso.dao.CuotasPagoDAO;
import pe.siso.dao.DAOFactory;
import pe.siso.dao.DescuentoDAO;
import pe.siso.dao.EnfermedadDAO;
import pe.siso.dao.LocalDAO;
import pe.siso.dao.MatriculaDAO;
import pe.siso.dao.MenuDAO;
import pe.siso.dao.PensionDAO;
import pe.siso.dao.PeriodoDAO;
import pe.siso.dao.RequisitoDAO;
import pe.siso.dao.SeguroDAO;
import pe.siso.dao.UbigeoDAO;
import pe.siso.dao.UsuarioDAO;

public class MySqlDAOFactory extends DAOFactory {

     static {
        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public static Connection obtenerConexion(String base) {
        Connection conexion = null;
        if (base.equals("matricula")) {

            try {

                conexion = DriverManager.getConnection(
                        /*"jdbc:mysql://172.16.0.18:3306/encuesta_docente", 
                                                            "eduardo", 
                                                            "mysql");*/
                        "jdbc:mysql://localhost:3306/siso",
                        "root",
                        "mysql123");

            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }

        } //  Otras BD
        else if (base.equals("cuotas_pago")) {

            try {
                conexion = DriverManager.getConnection(
                        "jdbc:mysql://localhost:3306/cuotas_pago",
                        //"jdbc:mysql://172.16.2.69:3306/sacoolive4",
                        "root",
                        "mysql123");

            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }

        }

        return conexion;
    }

    @Override
    public UbigeoDAO getUbigeoDAO() {
        return new MySqlUbigeoDAO();
    }

    @Override
    public MenuDAO getMenuDAO() {
        return new MySqlMenuDAO();
    }

    @Override
    public UsuarioDAO getUsuarioDAO() {
        return new MySqlUsuarioDAO();
    }

    @Override
    public PeriodoDAO getPeriodoDAO() {
        return new MySqlPeriodoDAO();
    }

    @Override
    public AlumnoDAO getAlumnoDAO() {
        return new MySqlAlumnoDAO();
    }

    @Override
    public ApoderadoDAO getApoderadoDAO() {
        return new MySqlApoderadoDAO();
    }

    @Override
    public EnfermedadDAO getEnfermedadDAO() {
        return new MySqlEnfermedadDAO();
    }

    @Override
    public MatriculaDAO getMatriculaDAO() {
        return  new MySqlMatriculaDAO();
    }

    @Override
    public AulaDAO getAulaDAO() {
        return  new MySqlAulaDAO();
    }

    @Override
    public LocalDAO getLocalDAO() {
        return  new MySqlLocalDAO();
   }

    @Override
    public PensionDAO getPensionDAO() {
        return new MySqlPensionDAO();
    }

    @Override
    public DescuentoDAO getDescuentoDAO() {
        return new MySqlDescuentoDAO();
    }

    @Override
    public RequisitoDAO getRequisitoDAO() {
        return new MySqlRequisitoDAO();
    }

    @Override
    public ColegioDAO getColegioDAO() {
        return new MySqlColegioDAO();
    }

    @Override
    public AlumnoHermanoDAO getAlumnoHermanoDAO() {
        return new  MySqlAlumnoHermano();
    }

    @Override
    public CuotasPagoDAO getCuotasPagoDAO() {
        return new  MySqlCuotasPagoDAO();
    }

    @Override
    public SeguroDAO getSeguroDAO() {
        return new MySqlSeguroDAO();
    }
    
}
