package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.beans.AlergiaBean;
import pe.siso.beans.EnfermedadBean;
import pe.siso.dao.EnfermedadDAO;

public class MySqlEnfermedadDAO implements EnfermedadDAO {

    @Override
    public ArrayList<EnfermedadBean> listarEnfermedad() throws Exception {
        ArrayList<EnfermedadBean> lista = new ArrayList<>();
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select cod_enf,nom_enf from enfermedad;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            EnfermedadBean enf = new EnfermedadBean();
            enf.setCodEnfermedad(rs.getInt("cod_enf"));
            enf.setSltEnfermedad(rs.getString("nom_enf"));
            lista.add(enf);
        }
        return lista;
    }

    @Override
    public int insertarEnfermedad(ArrayList<EnfermedadBean> enf, String codAlumno) throws Exception {
        int resultado = 0;
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        for (int i = 0; i < enf.size(); i++) {
            String query = "INSERT INTO alumno_enfermedad ( cod_alu_enf ,  cod_alu ,  cod_enf ,  est_enf ) VALUES (null, " + codAlumno + ", " + enf.get(i).getCodEnfermedad() + ", '" + enf.get(i).getSltEstado() + "');";
            resultado = st.executeUpdate(query);
        }

        return resultado;

    }

    @Override
    public int insertarAlergia(ArrayList<AlergiaBean> alergia, String codAlumno) throws Exception {
        int resultado = 0;
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        for (int i = 0; i < alergia.size(); i++) {
            String query = "INSERT INTO alumno_alergia ( cod_alergia ,  cod_alu ,  tip_alergia ,  des_alergia ,  rec_alergia ,  med_alergia ) VALUES (null," + codAlumno + ", '" + alergia.get(i).getSltEnfermedad() + "', '" + alergia.get(i).getTxtConcepto() + "', '" + alergia.get(i).getTxtReaccion() + "', '" + alergia.get(i).getTxtMedicEmer() + "');";
            resultado = st.executeUpdate(query);
        }
        return resultado;
    }

    @Override
    public ArrayList<EnfermedadBean> consultarEnfermedadPorAlumno(String codAlumno) throws Exception {
        ArrayList<EnfermedadBean> lista = new ArrayList<>();
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select cod_alu_enf,cod_alu,aen.cod_enf,est_enf,nom_enf from alumno_enfermedad aen\n"
                + "INNER JOIN enfermedad enf on aen.cod_enf=enf.cod_enf\n"
                + "WHERE cod_alu=" + codAlumno + "  ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            EnfermedadBean enf = new EnfermedadBean();
            enf.setCodAlumnoEnfermedad(rs.getInt("cod_alu_enf"));
            enf.setCodAlumno(rs.getInt("cod_alu"));
            enf.setSltEstado(rs.getString("est_enf"));
            enf.setCodEnfermedad(rs.getInt("cod_enf"));
            enf.setSltEnfermedad(rs.getString("nom_enf"));
            lista.add(enf);
        }
        return lista;
    }

    @Override
    public ArrayList<AlergiaBean> consultarAlergiaPorAlumno(String codAlumno) throws Exception {
        ArrayList<AlergiaBean> lista = new ArrayList<>();
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select cod_alergia,cod_alu,tip_alergia,des_alergia,rec_alergia,med_alergia from alumno_alergia WHERE cod_alu=" + codAlumno + " ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            AlergiaBean ale = new AlergiaBean();
            ale.setCodAlergia(rs.getInt("cod_alergia"));
            ale.setSltEnfermedad(rs.getString("tip_alergia"));
            ale.setTxtConcepto(rs.getString("des_alergia"));
            ale.setTxtReaccion(rs.getString("rec_alergia"));
            ale.setTxtMedicEmer(rs.getString("med_alergia"));
            lista.add(ale);
        }
        return lista;
    }

    @Override
    public int actualizarEnfermedadPorAlumno(ArrayList<EnfermedadBean> enfermedad, String codAlumno) throws Exception {
        int resultado = 0;
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        Statement st1 = cnx.createStatement();
        String query = "";
        String codEnfermedad = "0";
        for (EnfermedadBean enf : enfermedad) {
            if (enf.getCodAlumnoEnfermedad() == 0) {
                query = "INSERT INTO alumno_enfermedad ( cod_alu_enf ,  cod_alu ,  cod_enf ,  est_enf ) VALUES (null, " + codAlumno + ", " + enf.getCodEnfermedad() + ", '" + enf.getSltEnfermedad() + "');";
                st.executeUpdate(query);
                codEnfermedad += "," + enf.getCodEnfermedad();
            } else {
                codEnfermedad += "," + enf.getCodEnfermedad();
            }
        }
        query = "SELECT af.cod_alu_enf,cod_alu,cod_enf,est_enf,IF(IFNULL(x.cod_alu_enf,0)=0,0,1) estado  FROM alumno_enfermedad  af\n"
                + "LEFT JOIN ( select cod_alu_enf from alumno_enfermedad WHERE cod_enf in(" + codEnfermedad + ") )x on x.cod_alu_enf=af.cod_alu_enf\n"
                + "WHERE af.cod_alu=" + codAlumno + "  ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            if (rs.getInt("estado") == 0) {
                query = "delete from alumno_enfermedad WHERE cod_alu_enf=" + rs.getInt("cod_alu_enf") + "  ;";
                st1.executeUpdate(query);
            }

        }
        return resultado;
    }

    @Override
    public int actualizarAlergiaPorAlumno(ArrayList<AlergiaBean> alergia, int codAlumno) throws Exception {
        int resultado = 0;
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        Statement st1 = cnx.createStatement();
        String query = "";
        String codAlergia = "0";
        for (AlergiaBean ale : alergia) {
            if (ale.getCodAlergia() == 0) {
                query = "INSERT INTO alumno_alergia ( cod_alergia ,  cod_alu ,  tip_alergia ,  des_alergia ,  rec_alergia ,  med_alergia  ) VALUES (null, " + codAlumno + ", '" + ale.getSltEnfermedad() + "', '" + ale.getTxtConcepto() + "', '" + ale.getTxtReaccion() + "', '" + ale.getTxtMedicEmer() + "');";
                st.executeUpdate(query);
                ResultSet rs = st.getGeneratedKeys();
                if (rs.next()) {
                    codAlergia += "," + rs.getString(1);
                }
            } else {
                codAlergia += "," + ale.getCodAlergia();
            }
        }
        query = "SELECT aa.cod_alergia,IF(IFNULL(x.cod_alergia,0)=0,0,1) estado from alumno_alergia aa\n"
                + "LEFT JOIN (select cod_alergia from alumno_alergia WHERE cod_alergia in (" + codAlergia + ") ) x on x.cod_alergia=aa.cod_alergia\n"
                + "WHERE cod_alu=" + codAlumno + "  ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            if (rs.getInt("estado") == 0) {
                query = "DELETE FROM alumno_alergia WHERE cod_alergia=" + rs.getInt("cod_alergia") + " ;";
                st1.executeUpdate(query);
            }
        }
        return resultado;
    }
}
