/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import pe.siso.beans.AlumnoBean;
import pe.siso.beans.MatriculaBean;
import pe.siso.dao.MatriculaDAO;

/**
 *
 * @author sistem05user
 */
public class MySqlMatriculaDAO implements MatriculaDAO {

    @Override
    public ArrayList<MatriculaBean> listarMatricula(MatriculaBean matricula, int tipoBusqueda, String NombreCompleto, int inicio, int cantidad) throws Exception {
        ArrayList<MatriculaBean> lista = new ArrayList<>();
        String filtros = "";

        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();

        if (matricula.getCodPeriodo() != 0) {
            filtros = filtros + " and x.cod_per=" + matricula.getCodPeriodo();
        }

//        if (!(fecDesde.equals("")) && !(fecHasta.equals(""))) {
//            filtros = filtros + " and fm.fec_mat BETWEEN '" + fecDesde + "' and '" + fecHasta + "'";
//        }
        if (matricula.getAnioMat() != 0) {
            filtros = filtros + " and year(fec_mat) =" + matricula.getAnioMat();
        }
        if (matricula.getCodNivel() != 0) {
            filtros = filtros + " and x.cod_niv=" + matricula.getCodNivel();
        }

        if (matricula.getCodGrado() != 0) {
            filtros = filtros + " and x.cod_gra=" + matricula.getCodGrado();
        }

        if (matricula.getCodTurno() != 0) {
            filtros = filtros + " and   x.cod_tur=" + matricula.getCodTurno();
        }

        if (!(NombreCompleto.equals(""))) {
            filtros = filtros + " and CONCAT(a.ape_pat_alu,' ', a.ape_mat_alu,' ', a.nom_alu) LIKE '%" + NombreCompleto + "%'";
        }

        if (!matricula.getEstadoMatricula().equals("-1")) {
            filtros = filtros + " and x.estado_matri=" + matricula.getEstadoMatricula();
        }

        String whereSede;
        // FILTRO POR SEDE
        if (matricula.getCodSede().equals("1")) {
            whereSede = "WHERE x.cod_local!='' ";
        } else {
            whereSede = " WHERE x.cod_local='" + matricula.getCodSede() + "' ";
        }

        String query = "SELECT  x.cod_mat,x.cod_local_dcto,x.cod_inf,CONCAT( a.ape_pat_alu, ' ', a.ape_mat_alu, ' ', a.nom_alu) nombrecompleto, x.cod_alu, x.cod_aula, x.cod_niv, x.cod_gra, x.seccion, a.ape_pat_alu, a.ape_mat_alu, a.nom_alu, a.dni_alu, a.cod_ban_alu, niv.des_niv, x.cod_col, x.obs_mat, g.des_gra, t.des_tur, DATE_FORMAT( x.fec_mat, '%d/%m/%Y %h:%i %p' ) fec_mat, x.estado_matri, l.desLocal, p.des_per,IFNULL(ah.cod_grupo,0) cod_grupo  "
                + " FROM alumno a\n"
                + "INNER JOIN (\n"
                + "select fm.cod_mat,fm.cod_local_dcto,fm.cod_inf,fm.cod_per,fm.cod_alu,fm.cod_aula,fm.cod_col,fm.obs_mat,fm.fec_mat,fm.estado_matri,au.seccion,au.cod_local,au.cod_niv,au.cod_gra,au.cod_tur from ficha_matricula fm\n"
                + "INNER JOIN aula au on fm.cod_aula=au.cod_aula WHERE au.cod_local='" + matricula.getCodSede() + "' ORDER BY fec_mat DESC \n"
                + ") x on x.cod_alu=a.cod_alu\n"
                + "INNER JOIN nivel niv ON niv.cod_niv = x.cod_niv\n"
                + "INNER JOIN grado g ON g.cod_gra = x.cod_gra\n"
                + "INNER JOIN turno t ON t.cod_tur = x.cod_tur\n"
                + "INNER JOIN locales l ON l.codlocal = x.cod_local\n"
                + "INNER JOIN periodo p ON p.cod_per = x.cod_per "
                + "LEFT JOIN alumno_hermano ah on a.cod_alu=ah.cod_alu "
                + whereSede + filtros //+ " ORDER BY a.ape_pat_alu, a.ape_mat_alu, a.nom_alu "
                + " ORDER BY x.fec_mat DESC LIMIT " + inicio + "," + cantidad;

        System.out.println("LISTAR MATRÍCULAS --->" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            MatriculaBean mat = new MatriculaBean();
            mat.setCodMatricula(rs.getInt("cod_mat"));
            mat.setNombrecompleto(rs.getString("nombrecompleto"));
            mat.setCodAlumno(rs.getInt("cod_alu"));
            mat.setCodAula(rs.getInt("cod_aula"));
//            mat.setAp_paterno(rs.getString("ape_pat_alu"));
//            mat.setAp_materno(rs.getString("ape_mat_alu"));
//            mat.setNombres(rs.getString("nom_alu"));
            mat.setDni(rs.getString("dni_alu"));
            mat.setCodBanco(rs.getString("cod_ban_alu"));
            mat.setNomNivel(rs.getString("des_niv"));
            mat.setNomGrado(rs.getString("des_gra"));
            mat.setNomTurno(rs.getString("des_tur"));
            mat.setFechaMatricula(rs.getString("fec_mat"));
            mat.setEstadoMatricula(rs.getString("estado_matri"));
            if (mat.getEstadoMatricula().equals("1")) {
                mat.setEstadoMatricula("<span class=\"label label-flat border-primary text-primary-600\">MATRICULADO</span>");
            } else if (mat.getEstadoMatricula().equals("0")) {
                mat.setEstadoMatricula("<span class=\"label label-danger\" style='background-color: #0097A7; font-size: 11px;'>REINGRESO</span>");
            } else if (mat.getEstadoMatricula().equals("2")) {
                mat.setEstadoMatricula("<span class=\"label label-warning\"  style='background-color: #EC4040;'>RETIRADO</span>");
            } else if (mat.getEstadoMatricula().equals("3")) {
                mat.setEstadoMatricula("<span class=\"label label-warning\"  style='background-color: #EC4040;'>ETL</span>");
            }
            mat.setNomLocal(rs.getString("desLocal"));
            mat.setNomPeriodo(rs.getString("des_per"));
            mat.setCodColegioRef(rs.getInt("cod_col"));
            mat.setObsMatricula(rs.getString("obs_mat"));
            mat.setCodNivel(rs.getInt("cod_niv"));
            mat.setCodGrado(rs.getInt("cod_gra"));
            mat.setSeccion(rs.getString("seccion"));
            mat.setCodInforma(rs.getInt("cod_inf"));
            mat.setCodGrupoHermano(rs.getInt("cod_grupo"));
            mat.setCodDescuento(rs.getInt("cod_local_dcto"));

            lista.add(mat);
        }

        return lista;
    }

    @Override
    public int registrarMatricula(MatriculaBean m) throws Exception {
        Date Hoy = new Date();
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String fecha_actual = formateador.format(Hoy);

        int codMatricula = 0;
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);

        String query = "INSERT INTO ficha_matricula (cod_mat, cod_alu, cod_aula, cod_per, fec_mat, cod_local_dcto,"
                + " des_dcto, mon_dcto_pen, obs_mat, cod_inf, cod_col, usu_mat, fec_reg_mat, "
                + " usu_mod_mat, fec_mod_mat, estado_matri,mon_dcto_mat,tipo_matri)"
                + " VALUES (null, ?, ?, ?, now(), ?, ?, ?, ?, ?, ?, ?, now(), null, null, 1 ,?,?)";

        PreparedStatement pst = cnx.prepareStatement(query, PreparedStatement.RETURN_GENERATED_KEYS);
        pst.setInt(1, m.getCodAlumno());
        pst.setInt(2, m.getCodAula());
        pst.setInt(3, m.getCodPeriodo());
        pst.setInt(4, m.getCodDescuento());
        pst.setString(5, m.getNomDescuento());
        pst.setDouble(6, m.getMontoDescuentoPension());
        pst.setString(7, m.getObsMatricula());
        pst.setInt(8, m.getCodInforma());
        pst.setInt(9, m.getCodColegioRef());
        pst.setInt(10, m.getCodUsuarioMatriculante());
        pst.setDouble(11, m.getMontoDescuentoMatricula());
        pst.setInt(12, m.getTipoMatricula());
        System.out.println("INSERTAR FICHA MATRICULA --->" + query);
        pst.executeUpdate();

        ResultSet rs = pst.getGeneratedKeys();
        while (rs.next()) {
            codMatricula = rs.getInt(1);
        }
        System.out.println("RESULTADO codMatricula -->" + codMatricula);

        cnx.close();
        return codMatricula;

    }

    @Override
    public MatriculaBean consultarUltimaMatricula(int codAlumno, int anioPerActual) throws Exception {

        MatriculaBean m = new MatriculaBean();

        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT fm.cod_mat, fm.cod_alu,fm.mon_dcto_pen,fm.mon_dcto_mat,fm.cod_aula, fm.cod_per, fm.fec_mat, fm.cod_local_dcto, fm.des_dcto, "
                + "			fm.obs_mat, fm.cod_inf, fm.cod_col, fm.usu_mat, fm.fec_reg_mat, fm.estado_matri,p.anio_per "
                + " FROM ficha_matricula fm "
                + " INNER JOIN periodo p on p.cod_per=fm.cod_per "
                + " WHERE cod_alu=" + codAlumno + " AND anio_per<" + anioPerActual
                + " ORDER BY p.anio_per desc "
                + " LIMIT 0,1";

        System.out.println(query);

        ResultSet rs = st.executeQuery(query);

        if (rs.next()) {
            m.setCodMatricula(rs.getInt("cod_mat"));
            m.setCodAlumno(rs.getInt("cod_alu"));
            m.setCodPeriodo(rs.getInt("cod_per"));
            m.setFechaMatricula(rs.getString("fec_mat"));
            m.setCodDescuento(rs.getInt("cod_local_dcto"));
            m.setNomDescuento(rs.getString("des_dcto"));
            m.setMontoDescuentoMatricula(rs.getDouble("mon_dcto_mat"));
            m.setMontoDescuentoPension(rs.getDouble("mon_dcto_pen"));
            m.setObsMatricula(rs.getString("obs_mat"));
            m.setCodInforma(rs.getInt("cod_inf"));
            m.setCodColegioRef(rs.getInt("cod_col"));
            m.setCodUsuarioMatriculante(rs.getInt("usu_mat"));
            m.setFechaRegistroMatricula(rs.getString("fec_reg_mat"));
            m.setEstadoMatricula(rs.getString("estado_matri"));
            m.setCodAula(rs.getInt("cod_aula"));
            m.setNomPeriodo(rs.getString("anio_per"));
        }
        cnx.close();
        return m;
    }

    @Override
    public int cantMatricula(MatriculaBean matricula, int tipoBusqueda, String NombreCompleto) throws Exception {
        int cantidad = 0;
        String filtros = "";

        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();

        if (matricula.getCodPeriodo() != 0) {
            filtros = filtros + " and fm.cod_per=" + matricula.getCodPeriodo();
        }

//        if (!(fecDesde.equals("")) && !(fecHasta.equals(""))) {
//            filtros = filtros + " and fm.fec_mat BETWEEN '" + fecDesde + "' and '" + fecHasta + "'";
//        }
        if (matricula.getAnioMat() != 0) {
            filtros = filtros + " and year(fec_mat) =" + matricula.getAnioMat();
        }
        if (matricula.getCodNivel() != 0) {
            filtros = filtros + " and au.cod_niv=" + matricula.getCodNivel();
        }

        if (matricula.getCodGrado() != 0) {
            filtros = filtros + " and au.cod_gra=" + matricula.getCodGrado();
        }

        if (matricula.getCodTurno() != 0) {
            filtros = filtros + " and   au.cod_tur=" + matricula.getCodTurno();
        }

        if (!(NombreCompleto.equals(""))) {
            filtros = filtros + " and CONCAT(a.ape_pat_alu,' ', a.ape_mat_alu,' ', a.nom_alu) LIKE '%" + NombreCompleto + "%'";
        }

        if (!matricula.getEstadoMatricula().equals("-1")) {
            filtros = filtros + " and fm.estado_matri=" + matricula.getEstadoMatricula();
        }

        String whereSede;
        // FILTRO POR SEDE
        if (matricula.getCodSede().equals("1")) {
            whereSede = "WHERE au.cod_local!='' ";
        } else {
            whereSede = " WHERE au.cod_local='" + matricula.getCodSede() + "' ";
        }

        String query = "SELECT count(1) cant"
                + " FROM ficha_matricula fm "
                + " INNER JOIN alumno a on a.cod_alu=fm.cod_alu "
                + " INNER JOIN aula au on au.cod_aula=fm.cod_aula "
                //                + " INNER JOIN nivel niv on niv.cod_niv=au.cod_niv "
                //                + " INNER JOIN grado g on g.cod_gra=au.cod_gra "
                //                + " INNER JOIN turno t on t.cod_tur=au.cod_tur"
                //                + " INNER JOIN locales l on l.codlocal=au.cod_local"
                + " INNER JOIN periodo p on p.cod_per=fm.cod_per "
                + whereSede + filtros //+ " ORDER BY a.ape_pat_alu, a.ape_mat_alu, a.nom_alu "
                + " ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        System.out.println("Cantidad MATRÍCULAS --->" + query);
        return cantidad;
    }

    @Override
    public int actualizarMatricula(MatriculaBean matricula) throws Exception {
        Date Hoy = new Date();
        int resultado = 0;
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String fecha_actual = formateador.format(Hoy);
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st =cnx.createStatement();
        String query = "UPDATE ficha_matricula set cod_aula="+matricula.getCodAula()+",cod_local_dcto="+matricula.getCodDescuento()+",des_dcto='"+matricula.getNomDescuento()+"',mon_dcto_pen="+matricula.getMontoDescuentoPension()+",mon_dcto_mat="+matricula.getMontoDescuentoMatricula()+",obs_mat='"+matricula.getObsMatricula()+"',\n"
                + "cod_inf="+matricula.getCodInforma()+",cod_col="+matricula.getCodColegioRef()+",usu_mod_mat="+matricula.getCodUsuarioMatriculante()+",fec_mod_mat='"+fecha_actual+"',tipo_matri="+matricula.getTipoMatricula()+" WHERE cod_mat="+ matricula.getCodMatricula()+" ;";
        resultado=st.executeUpdate(query);
        return resultado;
    }

}
