package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.beans.InformaBean;
import pe.siso.beans.RequisitoBean;
import pe.siso.dao.RequisitoDAO;

public class MySqlRequisitoDAO implements RequisitoDAO {

    @Override
    public ArrayList<RequisitoBean> ListarDocumentos() throws Exception {
        ArrayList<RequisitoBean> lista = new ArrayList<>();
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "select cod_req,nom_req from requisitos where est_req=1 ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            RequisitoBean req = new RequisitoBean();
            req.setCodRequisito(rs.getInt("cod_req"));
            req.setNomRequisito(rs.getString("nom_req"));
            lista.add(req);
        }
        System.out.println("query- ListarDocumentos->" + query);
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<InformaBean> ListarInformes() throws Exception {
        ArrayList<InformaBean> lista = new ArrayList<>();
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_inf,des_inf from informa WHERE est_inf=1";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            InformaBean inf = new InformaBean();
            inf.setCodInforma(rs.getInt("cod_inf"));
            inf.setNomInforma(rs.getString("des_inf"));
            lista.add(inf);
        }
        System.out.println("query- ListarInformes->" + query);
        cnx.close();
        return lista;
    }

    @Override
    public int registrarFichaRequisito(int codFicha, int codRequisito) throws Exception {

        int resultado = 0;

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        String query = "INSERT INTO ficha_requisitos (cod_ficha_req, cod_ficha_mat, cod_req) VALUES (null, ?, ?)";

        PreparedStatement pst = cnx.prepareStatement(query);

        pst.setInt(1, codFicha);
        pst.setInt(2, codRequisito);

        System.out.println("" + query);
        resultado = pst.executeUpdate();

        System.out.println(resultado);
        cnx.close();
        return resultado;

    }

    @Override
    public ArrayList<RequisitoBean> FichaRequisito(int codFichaMatricula) throws Exception {

        ArrayList<RequisitoBean> lista = new ArrayList<>();
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "select rq.cod_req,nom_req,est_req,cod_ficha_req,cod_ficha_mat from requisitos rq INNER JOIN ficha_requisitos frq ON rq.cod_req=frq.cod_req WHERE cod_ficha_mat=" + codFichaMatricula + ";";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            RequisitoBean req = new RequisitoBean();
            req.setCodRequisito(rs.getInt("cod_req"));
            req.setNomRequisito(rs.getString("nom_req"));
            lista.add(req);
        }
        System.out.println("query- ListarInformes->" + query);
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<RequisitoBean> listarDocumentoPorAlumno(int codFichaMatricula) throws Exception {
        ArrayList<RequisitoBean> lista = new ArrayList<>();
        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "select cod_ficha_req,cod_ficha_mat,cod_req from ficha_requisitos WHERE cod_ficha_mat=" + codFichaMatricula + ";";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            RequisitoBean req = new RequisitoBean();
            req.setCodRequisito(rs.getInt("cod_req"));
            req.setCodFichaReq(rs.getInt("cod_ficha_req"));
//            req.setNomRequisito(rs.getString("nom_req"));
            lista.add(req);
        }
        System.out.println("query- ListarDocumentos->" + query);
        cnx.close();
        return lista;
    }
}
