/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.beans.SeguroBean;
import pe.siso.dao.SeguroDAO;

/**
 *
 * @author sistem05user
 */
public class MySqlSeguroDAO implements SeguroDAO {

    @Override
    public ArrayList<SeguroBean> listarSeguros() throws Exception {
        ArrayList<SeguroBean> lista = new ArrayList<>();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        String query = "SELECT cod_seg, nom_seg FROM seguro ORDER BY nom_seg;";

        System.out.println("" + query);
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            SeguroBean s = new SeguroBean();
            s.setCodSeguro(rs.getInt("cod_seg"));
            s.setNomSeguro(rs.getString("nom_seg"));
            lista.add(s);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int registrarAlumnoSeguro(int codAlumno, SeguroBean seguro) throws Exception {
        int resultado = 0;

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        String query = "INSERT INTO alumno_seguro (cod_alu_seg , cod_alu , cod_seg , nro_ase_seg , tel1_seg  ,dir_seg ) VALUES (null, ?, ?, ?, ?, ?);";

        PreparedStatement pst = cnx.prepareStatement(query);

        pst.setInt(1, codAlumno);
        pst.setInt(2, seguro.getCodSeguro());
        pst.setString(3, seguro.getNroAsegurado());
        pst.setString(4, seguro.getTelefono());
        pst.setString(5, seguro.getDireccionSeguro());

        System.out.println("" + query);
        resultado = pst.executeUpdate();

        System.out.println(resultado);
        cnx.close();
        return resultado;
    }

    @Override
    public ArrayList<SeguroBean> consultarSeguroPorAlumno(int codAlu) throws Exception {

        ArrayList<SeguroBean> lista = new ArrayList<SeguroBean>();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();

        String query = "select cod_alu_seg,cod_alu,als.cod_seg, nro_ase_seg, tel1_seg, tel2_seg, dir_seg, s.nom_seg"
                + " from alumno_seguro als"
                + " inner join seguro s on s.cod_seg=als.cod_seg"
                + " where cod_alu=" + codAlu;

        System.out.println("" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            SeguroBean s = new SeguroBean();
            s.setCodSeguroAlumno(rs.getInt("cod_alu_seg"));
            s.setCodAlumno(rs.getInt("cod_alu"));
            s.setCodSeguro(rs.getInt("cod_seg"));
            s.setNroAsegurado(rs.getString("nro_ase_seg"));
            s.setTelefono(rs.getString("tel1_seg"));
            s.setDireccionSeguro(rs.getString("dir_seg"));
            s.setNomSeguro(rs.getString("nom_seg"));
            lista.add(s);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int actualizarSeguroPorAlumno(ArrayList<SeguroBean> seguro, int codAlumno) throws Exception {
        int resultado = 0;
        String base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        Statement st1 = cnx.createStatement();
        String query = "";
        String codSeguro = "0";
        for (SeguroBean seg : seguro) {
            if (seg.getCodSeguroAlumno() == 0) {
                query = "INSERT INTO  alumno_seguro  (  cod_alu ,  cod_seg ,  nro_ase_seg ,  tel1_seg ,  tel2_seg ,  dir_seg ) VALUES ( "+codAlumno+", "+seg.getCodSeguro()+", '"+seg.getNroAsegurado()+"', '"+seg.getTelefono()+"', NULL, '"+seg.getDireccionSeguro()+"');";
                st.executeUpdate(query);
                ResultSet rs = st.getGeneratedKeys();
                if (rs.next()) {
                    codSeguro += "," + rs.getString(1);
                }
            } else {
                codSeguro += "," + seg.getCodSeguroAlumno();
            }
        }
        
        //corregir
        query = "select s.cod_alu_seg,IF(IFNULL(x.cod_alu_seg,0)=0,0,1) estado from alumno_seguro s\n"
                + "LEFT JOIN (SELECT cod_alu_seg FROM alumno_seguro WHERE cod_alu_seg in ("+codSeguro+")) x on s.cod_alu_seg=x.cod_alu_seg\n"
                + "WHERE cod_alu="+codAlumno+" ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            if (rs.getInt("estado") == 0) {
                query = "DELETE FROM alumno_seguro WHERE cod_alu_seg=" + rs.getInt("cod_alu_seg") + " ;";
                st1.executeUpdate(query);
            }
        }
        return resultado;
    }
}
