package pe.siso.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.beans.UbigeoBean;
import pe.siso.dao.UbigeoDAO;

public class MySqlUbigeoDAO implements UbigeoDAO {

    @Override
    public ArrayList<UbigeoBean> listarDepartamentos() throws Exception {

        ArrayList<UbigeoBean> departamentos = new ArrayList<>();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT DISTINCT cod_dep_ubi, nom_dep_ubi "
                + "FROM ubigeo WHERE cod_dep_ubi!=0 ORDER BY nom_dep_ubi;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            UbigeoBean ubi = new UbigeoBean();
            ubi.setCodigoDptoUbigeo(rs.getInt("cod_dep_ubi"));
            ubi.setNombreDptoUbigeo(rs.getString("nom_dep_ubi"));
            departamentos.add(ubi);
        }
        System.out.println("query-->" + query);
        cnx.close();
        return departamentos;
    }

    @Override
    public ArrayList<UbigeoBean> listarProvincias(String codigoDpto) throws Exception {
        ArrayList<UbigeoBean> provincias = new ArrayList<>();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT DISTINCT cod_pro_ubi, nom_pro_ubi "
                + "FROM ubigeo WHERE cod_dep_ubi='" + codigoDpto + "' AND cod_pro_ubi!=0 ORDER BY nom_pro_ubi";
        System.out.println("listarProvincias query-->" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            UbigeoBean ubi = new UbigeoBean();
            ubi.setCodigoProvUbigeo(rs.getInt("cod_pro_ubi"));
            ubi.setNombreProvUbigeo(rs.getString("nom_pro_ubi"));
            provincias.add(ubi);
        }

        cnx.close();
        return provincias;
    }

    @Override
    public ArrayList<UbigeoBean> listarDistritos(String codigoDpto, String codigoProv) throws Exception {

        ArrayList<UbigeoBean> distritos = new ArrayList<>();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT DISTINCT cod_dis_ubi, nom_dis_ubi "
                + "FROM ubigeo WHERE cod_dep_ubi='" + codigoDpto + "' AND cod_pro_ubi='" + codigoProv + "' and cod_dis_ubi!=0 ORDER BY nom_dis_ubi";

        System.out.println("listarDistrito query-->" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            UbigeoBean ubi = new UbigeoBean();
            ubi.setCodigoDistUbigeo(rs.getInt("cod_dis_ubi"));
            ubi.setNombreDistUbigeo(rs.getString("nom_dis_ubi"));
            distritos.add(ubi);
        }

        cnx.close();
        return distritos;
    }

    @Override
    public UbigeoBean consultarUbigeo(int codUbigeo) throws Exception {

        UbigeoBean ubi = new UbigeoBean();

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_ubi, cod_dep_ubi, cod_pro_ubi, cod_dis_ubi, nom_dep_ubi, nom_pro_ubi, nom_dis_ubi "
                + " FROM ubigeo WHERE cod_ubi=" + codUbigeo;

        System.out.println("consultarUbigeo query-->" + query);
        ResultSet rs = st.executeQuery(query);

        if (rs.next()) {
            ubi.setCodigoUbigeo(rs.getInt("cod_ubi"));

            ubi.setCodigoDptoUbigeo(rs.getInt("cod_dep_ubi"));
            ubi.setCodigoProvUbigeo(rs.getInt("cod_pro_ubi"));
            ubi.setCodigoDistUbigeo(rs.getInt("cod_dis_ubi"));

            ubi.setNombreDptoUbigeo(rs.getString("nom_dep_ubi"));
            ubi.setNombreProvUbigeo(rs.getString("nom_pro_ubi"));
            ubi.setNombreDistUbigeo(rs.getString("nom_dis_ubi"));
        }

        cnx.close();
        return ubi;

    }

    @Override
    public int consultarCodUbi(int codDpto, int codProv, int codDist) throws Exception {

        int codUbi = 0;

        String Base = "matricula";
        Connection cnx = MySqlDAOFactory.obtenerConexion(Base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_ubi "
                + "FROM ubigeo "
                + "WHERE cod_dep_ubi=" + codDpto + " and cod_pro_ubi=" + codProv + " and cod_dis_ubi=" + codDist;

        ResultSet rs = st.executeQuery(query);

        if (rs.next()) {
            codUbi = rs.getInt("cod_ubi");
        }

        cnx.close();
        return codUbi;
    }

}
