package pe.siso.services;

import java.util.ArrayList;
import pe.siso.beans.AlergiaBean;
import pe.siso.beans.EnfermedadBean;
import pe.siso.dao.DAOFactory;
import pe.siso.dao.EnfermedadDAO;

public class EnfermedadService {

    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    EnfermedadDAO objEnfermedadDAO = fabrica.getEnfermedadDAO();

    public ArrayList<EnfermedadBean> listarEnfermedad() {
        ArrayList<EnfermedadBean> lista = new ArrayList<>();
        try {
            lista = objEnfermedadDAO.listarEnfermedad();
        } catch (Exception e) {
        }
        return lista;
    }

    public int insertarEnfermedad(ArrayList<EnfermedadBean> enf, String codAlumno) {
        int resultado = 0;
        try {
            resultado = objEnfermedadDAO.insertarEnfermedad(enf, codAlumno);
        } catch (Exception e) {
        }
        return resultado;
    }

    public int insertarAlergia(ArrayList<AlergiaBean> alergia, String codAlumno) {
        int resultado = 0;
        try {
            resultado = objEnfermedadDAO.insertarAlergia(alergia, codAlumno);
        } catch (Exception e) {
        }
        return resultado;
    }

    public ArrayList<EnfermedadBean> consultarEnfermedadPorAlumno(String codAlumno) {
        ArrayList<EnfermedadBean> lista = new ArrayList<>();
        try {
            lista = objEnfermedadDAO.consultarEnfermedadPorAlumno(codAlumno);
        } catch (Exception e) {
        }
        return lista;
    }

    public ArrayList<AlergiaBean> consultarAlergiaPorAlumno(String codAlumno) {
        ArrayList<AlergiaBean> lista = new ArrayList<>();
        try {
            lista = objEnfermedadDAO.consultarAlergiaPorAlumno(codAlumno);
        } catch (Exception e) {
        }
        return lista;
    }

    public int actualizarEnfermedadPorAlumno(ArrayList<EnfermedadBean> enfermedad, String codAlumno) {
        int resultado = 0;
        try {
            resultado = objEnfermedadDAO.actualizarEnfermedadPorAlumno(enfermedad, codAlumno);
        } catch (Exception e) {
        }
        return resultado;
    }
    public int actualizarAlergiaPorAlumno(ArrayList<AlergiaBean> alergia, int codAlumno){
        int resultado=0;
        try {
            resultado=objEnfermedadDAO.actualizarAlergiaPorAlumno(alergia, codAlumno);
        } catch (Exception e) {
        }
        return resultado;
    }
}
