package pe.siso.services;

import java.util.ArrayList;
import pe.siso.beans.SeguroBean;
import pe.siso.dao.DAOFactory;
import pe.siso.dao.SeguroDAO;

public class SeguroServices {

    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    SeguroDAO objSeguroDAO = fabrica.getSeguroDAO();

    public ArrayList<SeguroBean> listarSeguros() {
        ArrayList<SeguroBean> lista = new ArrayList<>();
        try {
            lista = objSeguroDAO.listarSeguros();
        } catch (Exception e) {
        }
        return lista;
    }

    public int registrarAlumnoSeguro(int codAlumno, SeguroBean seguro) {
        int resultado = 0;
        try {
            resultado = objSeguroDAO.registrarAlumnoSeguro(codAlumno, seguro);
        } catch (Exception e) {
        }
        return resultado;
    }

    public ArrayList<SeguroBean> consultarSeguroPorAlu(int codAlu) {
        ArrayList<SeguroBean> lista = new ArrayList<>();
        try {
            lista = objSeguroDAO.consultarSeguroPorAlumno(codAlu);
        } catch (Exception e) {
        }
        return lista;
    }
      public int actualizarSeguroPorAlumno(ArrayList<SeguroBean> seguro, int codAlumno) {
          int resultado=0;
          try {
              resultado=objSeguroDAO.actualizarSeguroPorAlumno(seguro, codAlumno);
          } catch (Exception e) {
          }
          return resultado;
      }

}
