
package pe.siso.services;

import java.util.ArrayList;
import pe.siso.beans.UbigeoBean;
import pe.siso.dao.DAOFactory;
import pe.siso.dao.UbigeoDAO;


public class UbigeoServices {
    
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    UbigeoDAO objUbigeoDAO = fabrica.getUbigeoDAO();
    
    public ArrayList<UbigeoBean> listarDepartamentos(){
        
        ArrayList<UbigeoBean> departamentos = null;
        
        try {
            
            departamentos = objUbigeoDAO.listarDepartamentos();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return departamentos;
    }
    
    public ArrayList<UbigeoBean> listarProvincias(String codigoDpto){
    
        ArrayList<UbigeoBean> provincias = null;
        
        try {
            
            provincias = objUbigeoDAO.listarProvincias(codigoDpto);
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return provincias;
    }
    
    public ArrayList<UbigeoBean> listarDistritos(String codigoDpto, String codigoProv){
    
        ArrayList<UbigeoBean> distritos = null;
        
        try {
            
            distritos = objUbigeoDAO.listarDistritos(codigoDpto,codigoProv);
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return distritos;
    }
    
    public UbigeoBean consultarUbigeo(int codUbigeo){
        
        UbigeoBean ubi = new UbigeoBean();
        
        try {
            ubi = objUbigeoDAO.consultarUbigeo(codUbigeo);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ubi;        
    }
    
    public int consultarCodUbi(int codDpto, int codProv, int codDist){
        int codUbi=0;
        
        try {
            codUbi = objUbigeoDAO.consultarCodUbi(codDpto, codProv, codDist);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return codUbi;
    }
    
}
