/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.servlets;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import java.io.IOException;
import java.io.PrintWriter;
import javax.json.stream.JsonParser;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import pe.siso.services.AlumnoServices;
//Añadir el type
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import pe.siso.beans.AlergiaBean;
import pe.siso.beans.AlumnoBean;
import pe.siso.beans.ApoderadoBean;
import pe.siso.beans.ComparadorGrupo;
import pe.siso.beans.EnfermedadBean;
import pe.siso.beans.PeriodoBean;
import pe.siso.beans.SeguroBean;
import pe.siso.services.ApoderadoServices;
import pe.siso.services.EnfermedadService;
import pe.siso.services.PeriodoServices;
import pe.siso.services.SeguroServices;

/**
 *
 * @author sistem05user
 */
public class AlumnoServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        String param = request.getParameter("Accion");

        if ("listarAlumno".equals(param)) {
            listarAlumno(request, response);
        } else if ("codHermanos".equals(param)) {
            codHermanos(request, response);
        } else if ("registrarAlumno".equals(param)) {
            registrarAlumno(request, response);
        } else if ("editarAlumno".equals(param)) {
            editarAlumno(request, response);
        } else if ("ConsultarAlumnoExitente".equals(param)) {
            ConsultarAlumnoExitente(request, response);
        }
    }

    private void listarAlumno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int cantidad = 0;
        String tipoDocumento = request.getParameter("tipoDocumento");
        String BuscarHermano = request.getParameter("BuscarHermano");
        int vstart = Integer.parseInt(request.getParameter("start"));
        int vlength = Integer.parseInt(request.getParameter("length"));
        int vdraw = Integer.parseInt(request.getParameter("draw"));
        AlumnoServices servicio = new AlumnoServices();
        PeriodoServices servicioper = new PeriodoServices();
        PeriodoBean periodo = servicioper.consultarPeriodoActual();
        JSONArray jsonAlumno = new JSONArray(servicio.listaAlumno(tipoDocumento, BuscarHermano, periodo.getCodPer() + "", vstart, vlength));
        cantidad = servicio.CantlistaAlumno(tipoDocumento, BuscarHermano, "0");
        JSONObject jsonReturn = new JSONObject();

        jsonReturn.put("data", jsonAlumno);
        jsonReturn.put("recordsFiltered", cantidad);
        jsonReturn.put("recordsTotal", cantidad);
        jsonReturn.put("draw", vdraw);
        System.out.println("SERVERLET ALUMNO" + jsonAlumno);
        pw.println(jsonReturn);
    }

    private void codHermanos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();

        int codGrupo = Integer.parseInt(request.getParameter("codGrupo"));
        int codAlumno = Integer.parseInt(request.getParameter("codAlumno"));
        AlumnoServices servicio = new AlumnoServices();
        String codHermanos = "";
        codHermanos = servicio.codHermanos(codAlumno, codGrupo);
        JSONArray jsonAlumno = new JSONArray(servicio.listaAlumno("4", codHermanos, "0", 0, 999999));

        System.out.println("prueba");
        pw.println(jsonAlumno);
    }

    private void registrarAlumno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();

        String jsonalumno = request.getParameter("jsonAlumno");
        String myJsonApoderado = request.getParameter("myJsonApoderado");
        String myJsonHermanos = request.getParameter("myJsonHermanos");
        String myJsonEnfermedades = request.getParameter("myJsonEnfermedades");
        String myJsonAlergias = request.getParameter("myJsonAlergias");
        String myJsonSeguro = request.getParameter("myJsonSeguro");
        Gson gson = new Gson();
        Type typeAlumno = new TypeToken<List<AlumnoBean>>() {
        }.getType();
        Type typeHermano = new TypeToken<List<AlumnoBean>>() {
        }.getType();
        Type typeApoderado = new TypeToken<List<ApoderadoBean>>() {
        }.getType();
        Type typeEnfermedad = new TypeToken<List<EnfermedadBean>>() {
        }.getType();
        Type typeAlergia = new TypeToken<List<AlergiaBean>>() {
        }.getType();
        Type typeSeguro = new TypeToken<List<SeguroBean>>() {
        }.getType();

        ArrayList<AlumnoBean> datosAlumno = gson.fromJson(jsonalumno, typeAlumno);
        ArrayList<AlumnoBean> datosHermano = gson.fromJson(myJsonHermanos, typeHermano);
        ArrayList<ApoderadoBean> datosApoderado = gson.fromJson(myJsonApoderado, typeApoderado);
        ArrayList<EnfermedadBean> datosEnfermedad = gson.fromJson(myJsonEnfermedades, typeEnfermedad);
        ArrayList<AlergiaBean> datosAlergia = gson.fromJson(myJsonAlergias, typeAlergia);
        ArrayList<SeguroBean> datosseguro = gson.fromJson(myJsonSeguro, typeSeguro);

        AlumnoServices servicioAlu = new AlumnoServices();
        ApoderadoServices servicioApo = new ApoderadoServices();
        EnfermedadService servicioEnf = new EnfermedadService();
        SeguroServices servicoSeg = new SeguroServices();
        int resultado = 0;

        String codAlumno = servicioAlu.registrarAlumno(datosAlumno);
        resultado = servicioApo.registrarApoderado(datosApoderado, codAlumno);
        resultado = servicioEnf.insertarEnfermedad(datosEnfermedad, codAlumno);
        resultado = servicioEnf.insertarAlergia(datosAlergia, codAlumno);

        try {
            AlumnoBean maxgrupo = Collections.max(datosHermano, new ComparadorGrupo());
            resultado = servicioAlu.registrarHermanos(datosHermano, maxgrupo.getCodGrupo(), codAlumno);
        } catch (Exception e) {
            System.out.println("No se encontro Hermanos");
        }
        for (SeguroBean seguro : datosseguro) {
            servicoSeg.registrarAlumnoSeguro(Integer.parseInt(codAlumno), seguro);
        }
        //seccionar json o array con el codigo del alumno
        PeriodoBean per = new PeriodoBean();
        PeriodoServices servicioPer = new PeriodoServices();
        per = servicioPer.consultarPeriodoActual();
//        JSONArray datosAlumno=servicioAlu.
        JSONArray jsonDatosAlumnoNEW = new JSONArray(servicioAlu.listaAlumno("4", codAlumno, per.getCodPer() + "", 0, 1));
        pw.println(jsonDatosAlumnoNEW);

    }

    private void editarAlumno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();

        String jsonalumno = request.getParameter("jsonAlumno");
        String myJsonApoderado = request.getParameter("myJsonApoderado");
        String myJsonHermanos = request.getParameter("myJsonHermanos");
        String myJsonEnfermedades = request.getParameter("myJsonEnfermedades");
        String myJsonAlergias = request.getParameter("myJsonAlergias");
        String myJsonSeguro = request.getParameter("myJsonSeguro");

        Gson gson = new Gson();
        Type typeAlumno = new TypeToken<List<AlumnoBean>>() {
        }.getType();
        Type typeHermano = new TypeToken<List<AlumnoBean>>() {
        }.getType();
        Type typeApoderado = new TypeToken<List<ApoderadoBean>>() {
        }.getType();
        Type typeEnfermedad = new TypeToken<List<EnfermedadBean>>() {
        }.getType();
        Type typeAlergia = new TypeToken<List<AlergiaBean>>() {
        }.getType();
        Type typeSeguro = new TypeToken<List<SeguroBean>>() {
        }.getType();

        ArrayList<AlumnoBean> datosAlumno = gson.fromJson(jsonalumno, typeAlumno);
        ArrayList<AlumnoBean> datosHermano = gson.fromJson(myJsonHermanos, typeHermano); // quitar el alumno
        ArrayList<ApoderadoBean> datosApoderado = gson.fromJson(myJsonApoderado, typeApoderado);
        ArrayList<EnfermedadBean> datosEnfermedad = gson.fromJson(myJsonEnfermedades, typeEnfermedad);
        ArrayList<AlergiaBean> datosAlergia = gson.fromJson(myJsonAlergias, typeAlergia);
        ArrayList<SeguroBean> datosSeguro = gson.fromJson(myJsonSeguro, typeSeguro);
        AlumnoServices servicioAlu = new AlumnoServices();
        ApoderadoServices servicioApo = new ApoderadoServices();
        EnfermedadService servicioEnf = new EnfermedadService();
        SeguroServices servicoSeg = new SeguroServices();
        AlumnoBean maxgrupo = new AlumnoBean();

        int resultado = servicioAlu.actualizarAlumno(datosAlumno);
        resultado = servicioApo.ActualizarApoderado(datosApoderado, "" + (datosAlumno.get(0).getCodigo()));
        servicioAlu.actualizarHermano(datosHermano, datosAlumno.get(0).getCodGrupo(), "" + datosAlumno.get(0).getCodigo());
        servicioEnf.actualizarEnfermedadPorAlumno(datosEnfermedad, "" + datosAlumno.get(0).getCodigo());
        servicioEnf.actualizarAlergiaPorAlumno(datosAlergia, datosAlumno.get(0).getCodigo());
        servicoSeg.actualizarSeguroPorAlumno(datosSeguro, datosAlumno.get(0).getCodigo());
        JSONObject prueba = new JSONObject("{estado:1}");
        System.out.println(" datosAlumno ---->>>" + resultado + "");
        pw.println(prueba);

    }

    private void ConsultarAlumnoExitente(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AlumnoServices servicio = new AlumnoServices();
        int codigoAlumno;
        int tipoDocumento = Integer.parseInt(request.getParameter("tipoDocumento"));
        String documenAlumno = request.getParameter("documenAlumno");
        String nombreAlumno = request.getParameter("nombreAlumno");
        String apellidoMaterno = request.getParameter("apellidoMaterno");
        String apelidoPaterno = request.getParameter("apelidoPaterno");
        try {
            codigoAlumno = Integer.parseInt(request.getParameter("codigoAlumno"));
        } catch (Exception e) {
            codigoAlumno = 0;
        }
        JSONObject jsonAlumnoExitente = new JSONObject(servicio.ConsultarAlumnoExitente(codigoAlumno, tipoDocumento, documenAlumno, nombreAlumno, apellidoMaterno, apelidoPaterno));
        pw.println(jsonAlumnoExitente);
    }

}
