/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import pe.siso.beans.AulaBean;
import pe.siso.beans.MatriculaBean;
import pe.siso.beans.PeriodoBean;
import pe.siso.services.AulaServices;
import pe.siso.services.MatriculaServices;
import pe.siso.services.PeriodoServices;

/**
 *
 * @author sistem05user
 */
public class AulaServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        String param = request.getParameter("Accion");

        if ("listarNivel".equals(param)) {
            listarNivel(request, response);
        } else if ("listarGrado".equals(param)) {
            listarGrado(request, response);
        } else if ("listarTurno".equals(param)) {
            listarTurno(request, response);
        } else if ("CodigoAula".equals(param)) {
            CodigoAula(request, response);
        }else if ("ProximoAula".equals(param)) {
            ProximoAula(request, response);
        }
    }

    private void listarNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AulaServices servicio = new AulaServices();
        String codLocal = request.getParameter("codLocal");
        JSONArray jsonNivel = new JSONArray(servicio.listarNiveles(codLocal));
        pw.println(jsonNivel);
    }

    private void listarGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AulaServices servicio = new AulaServices();
        String codLocal = request.getParameter("codLocal");
        int codNivel = Integer.parseInt(request.getParameter("codNivel"));
        JSONArray jsonGrado = new JSONArray(servicio.listarGrados(codNivel, codLocal));
        pw.println(jsonGrado);

    }

    private void listarTurno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AulaServices servicio = new AulaServices();
        String codLocal = request.getParameter("codLocal");
        JSONArray jsonGrado = new JSONArray(servicio.listarTurnos(codLocal));
        pw.println(jsonGrado);

    }

    private void CodigoAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AulaServices servicio = new AulaServices();

        String codLocal = request.getParameter("codLocal");
        int codNivel = Integer.parseInt(request.getParameter("codNivel"));
        int codGrado = Integer.parseInt(request.getParameter("codGrado"));
        String nomTurno = request.getParameter("codTurno");
        int codTurno = 0;
        String Seccion = request.getParameter("Seccion");
        AulaBean aula = new AulaBean();
        aula.setCodLocal(codLocal);
        aula.setCodNivel(codNivel);
        aula.setCodGrado(codGrado);

        switch (nomTurno) {
            case "MAÑANA":
                codTurno = 1;
                break;
            case "TARDE":
                codTurno = 2;
                break;
            case "NOCHE":
                codTurno = 3;
                break;
        }
        aula.setCodTurno(codTurno);
        aula.setSeccion(Seccion);
        int codAula = 0;
        codAula = servicio.CodigoAula(aula);
        aula.setCodigo(codAula);
        JSONObject jsonAula = new JSONObject(aula);
        pw.println(jsonAula);
    }

    private void ProximoAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        AulaBean aula = new AulaBean();
        String codlocal = request.getParameter("codLocal");
        int codAlu = Integer.parseInt(request.getParameter("codAlumno"));
        JSONObject retornar = new JSONObject();
        AulaServices servicio = new AulaServices();

        //CONSULTAMOS EL PERIODO ACTUAL
        PeriodoServices servicioPer = new PeriodoServices();
        PeriodoBean per = servicioPer.consultarPeriodoActual();
        int anioActual = per.getAnioPer();

        //CONSULTAMOS LA ULTIMA MATRICULA DEL ALUMNO
        MatriculaServices servicioMat = new MatriculaServices();
        System.out.println("CONSULTAMOS ULTIMA MATRICULA");
        MatriculaBean mat = servicioMat.consultarUltimaMatricula(codAlu, anioActual);
//        RequisitosServices servicioReq = new RequisitosServices();
        int intervTiempo = 0;
        try {
            intervTiempo = anioActual - Integer.parseInt(mat.getNomPeriodo());
        } catch (Exception e) {

        }

        aula = servicio.AulaProximo(codlocal, mat.getCodAula(), intervTiempo);

        retornar.put("cod_aula", aula.getCodigo());
        retornar.put("cod_nivel", aula.getCodNivel());
        retornar.put("cod_grado", aula.getCodGrado());
        retornar.put("obsMatr", mat.getObsMatricula());
//        retornar.put("Req", reqsito);
        retornar.put("info", mat.getCodInforma());

        pw.println(retornar);
    }
}
