package pe.siso.servlets;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Type;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import pe.siso.beans.AlumnoHermanoBean;
import pe.siso.beans.CuotasPagoBean;
import pe.siso.beans.DescuentoHermanoBean;
import pe.siso.beans.MatriculaBean;
import pe.siso.beans.PeriodoBean;
import pe.siso.services.AlumnoServices;
import pe.siso.services.CuotasPagoServices;
import pe.siso.services.MatriculaServices;
import pe.siso.services.PeriodoServices;
import pe.siso.services.RequisitoServices;

public class MatriculaServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        String param = request.getParameter("Accion");

        if ("listarMatricula".equals(param)) {
            listarMatricula(request, response);
        } else if ("registrarMatricula".equals(param)) {
            registrarMatricula(request, response);
        } else if ("fichaMatriculaDatosAlumno".equals(param)) {
            fichaMatriculaDatosAlumno(request, response);
        } else if ("cuotasFichaMatricula".equals(param)) {
            cuotasFichaMatricula(request, response);
        } else if ("actualizarMatricula".equals(param)) {
            actualizarMatricula(request, response);
        }
    }

    private void listarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();

        MatriculaBean matricula = new MatriculaBean();
//        String fechaDesde = request.getParameter("fechaDesde");
//        String fechaHasta = request.getParameter("fechaHasta"); 
        String codLocal = request.getParameter("codLocal");
        int vstart = Integer.parseInt(request.getParameter("start"));
        int vlength = Integer.parseInt(request.getParameter("length"));
        int vdraw = Integer.parseInt(request.getParameter("draw"));
        int tipoBusqueda = Integer.parseInt(request.getParameter("tipoBusqueda"));
        if (tipoBusqueda == 1) {
            matricula.setCodPeriodo(Integer.parseInt(request.getParameter("busqueda")));
        } else if (tipoBusqueda == 3) {
            matricula.setAnioMat(Integer.parseInt(request.getParameter("busqueda")));
        }
//        int AnioMat = Integer.parseInt(request.getParameter("AnioMat")); // Año por fecha de matricula
        int codNivel = Integer.parseInt(request.getParameter("codNivel"));
        int codGrado = Integer.parseInt(request.getParameter("codGrado"));
        int codTurno = Integer.parseInt(request.getParameter("codTurno"));
        String nombreCompleto = request.getParameter("nombreCompleto");
        String codEstado = request.getParameter("codEstado");

//        PeriodoServices servicioper = new PeriodoServices();
//        PeriodoBean per =servicioper.consultarPeriodoActual();
        matricula.setCodSede(codLocal);
        matricula.setCodNivel(codNivel);
        matricula.setCodGrado(codGrado);
        matricula.setCodTurno(codTurno);
        matricula.setEstadoMatricula(codEstado);

//        matricula.setAnioMat(AnioMat);
//        matricula.setCodPeriodo(per.getCodPer());
        MatriculaServices servicio = new MatriculaServices();
        JSONArray jsonMatriculas = new JSONArray(servicio.listarMatricula(matricula, tipoBusqueda, nombreCompleto, vstart, vlength));
        System.out.println("jsonmatricula ->" + jsonMatriculas);
        int cantidadAlumno = servicio.cantMatricula(matricula, tipoBusqueda, nombreCompleto);

        JSONObject jsonReturn = new JSONObject();

        jsonReturn.put("data", jsonMatriculas);
        jsonReturn.put("recordsFiltered", cantidadAlumno);
        jsonReturn.put("recordsTotal", cantidadAlumno);
        jsonReturn.put("draw", vdraw);
//        System.out.println("SERVERLET ALUMNO" + jsonAlumno);
        pw.println(jsonReturn);

    }

    private void registrarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codMatricula = 0;
        int codAlumno = Integer.parseInt(request.getParameter("codAlumno"));
        int CodAula = Integer.parseInt(request.getParameter("CodAula"));
        int codDescuento = Integer.parseInt(request.getParameter("codDescuento"));
        String nombreDescuento = request.getParameter("nombreDescuento");

        double montoMatricula = Double.parseDouble(request.getParameter("montoMatricula"));
        double montoPension = Double.parseDouble(request.getParameter("montoPension"));

        double montDescuentoPension = Double.parseDouble(request.getParameter("montDescuentoPension"));
        double montDescuentoMatricula = Double.parseDouble(request.getParameter("montDescuentoMatricula"));
        int tipoMoneda;
        try {
            tipoMoneda = Integer.parseInt(request.getParameter("tipoMoneda"));
        } catch (Exception e) {
            tipoMoneda = 0;
        }

        String observacion = request.getParameter("observacion");
        int codInformes = Integer.parseInt(request.getParameter("codInformes"));
        int codColegioProc = Integer.parseInt(request.getParameter("codColegioProc"));
        int codUsuario = Integer.parseInt(request.getParameter("codUsuario"));
        String codDocumento[] = request.getParameter("codDocumento").split(",");
        int tipoMatricula = Integer.parseInt(request.getParameter("tipoMatricula"));
        int activarDescuento = Integer.parseInt(request.getParameter("activarDescuento"));
        String jsonHermano = request.getParameter("myJsonHermanos");

        Gson gson = new Gson();
        Type typeHermano = new TypeToken<List<DescuentoHermanoBean>>() {
        }.getType();
        ArrayList<DescuentoHermanoBean> datosHermano = gson.fromJson(jsonHermano, typeHermano);
        PeriodoServices servicioPeriodo = new PeriodoServices();
        //*********************************Consultar Periodo Actual****************************
        PeriodoBean periodo = new PeriodoBean();
        periodo = servicioPeriodo.consultarPeriodoActual();
        //*********************************Consultar Periodo Actual****************************

        MatriculaBean matricula = new MatriculaBean();
        matricula.setCodAlumno(codAlumno);
        matricula.setCodAula(CodAula);
        matricula.setCodPeriodo(periodo.getCodPer());
        matricula.setCodDescuento(codDescuento);
        matricula.setNomDescuento(nombreDescuento);
        matricula.setMontoDescuentoMatricula(montDescuentoMatricula);
        if (tipoMoneda == 1) {
            matricula.setMontoDescuentoPension(montDescuentoPension);
        } else {
            matricula.setMontoDescuentoPension(montoPension * (montDescuentoPension / 100));
        }

        matricula.setObsMatricula(observacion);
        matricula.setCodInforma(codInformes);
        matricula.setCodColegioRef(codColegioProc);
        matricula.setCodUsuarioMatriculante(codUsuario);
        matricula.setTipoMatricula(tipoMatricula);
        
        MatriculaServices servicio = new MatriculaServices();
        CuotasPagoServices Serviocuota = new CuotasPagoServices();

        //******************Registro Matricula***********************
        codMatricula = servicio.registrarMatricula(matricula);

        //*****************Fecha Segun  el  periodo actual **********************
        String fechaVenc = periodo.getFecVencMat();
        String[] valores = fechaVenc.split("-");
        String anio = valores[0];
        String mes = valores[1];
        String dia = valores[2];
        String fechaVencFinal = dia + "/" + mes + "/" + anio;
        String anio2 = String.valueOf(periodo.getAnioPer());
        //****************CUOTAS PAGO***************************
        String[] meses = new String[10];
        meses[0] = "P. Marzo";
        meses[1] = "P. Abril";
        meses[2] = "P. Mayo";
        meses[3] = "P. Junio";
        meses[4] = "P. Julio";
        meses[5] = "P. Agosto";
        meses[6] = "P. Setiembre";
        meses[7] = "P. Octubre";
        meses[8] = "P. Noviembre";
        meses[9] = "P. Diciembre";

        ArrayList<CuotasPagoBean> listaCuotas = new ArrayList<>();
        CuotasPagoBean c = new CuotasPagoBean();

        //Guardamos en una lista el primer registro (MATRICULA)
        c.setCod_fic_mat(codMatricula);
        c.setTip_cuota(1);
        c.setDes_cuota("Matricula");
        if (datosHermano.size() > 1) {
//*********************DESCUENTO POR HERMANO*******************
            for (DescuentoHermanoBean decHermano : datosHermano) {
                if (decHermano.getCodAlumno() == codAlumno) {
                    //HERMANO ACTUAL O ALUMNO MATRICULANDO
                    c.setDes_mot_cou(decHermano.getNomDesMatricula());
                    c.setTot_cuo(montoMatricula - decHermano.getMontoDesMatricula());
                    if (decHermano.getTpmontoMatricula() == 1) {
                        c.setDescuento_cuo(decHermano.getMontoDesMatricula());
                    } else {
                        c.setDescuento_cuo(montoMatricula * (decHermano.getMontoDesMatricula()) / 100);
                    }
                } else {
                    int ResultadaHermano = Serviocuota.ActualizarCuotaPagoPorDescHerm(decHermano);
                    /// Cambio de pensiones alumnos o matricula
                }
            }
        } else {
//*********************DESCUENTO NORMAL*******************
            c.setTot_cuo(montoMatricula);
            c.setDes_mot_cou(nombreDescuento);
            if (tipoMoneda == 1) {//monto en soles
                c.setDescuento_cuo(montDescuentoMatricula);
            } else { //monto en porcentaje 
                c.setDescuento_cuo(montoMatricula * ((montDescuentoMatricula) / 100));
            }
        }

// ************************************************************      
        c.setFec_ven(fechaVenc);
        c.setMon_cuo(montoMatricula);

        // PARA CUOTAS PAGO
        c.setNroCuota(-1);
        c.setCalcMora(0);

        listaCuotas.add(c);

        int cantMeses = 3;
        for (int i = 0; i < meses.length; i++) {

            CuotasPagoBean c2 = new CuotasPagoBean();
            c2.setCod_fic_mat(codMatricula);
            c.setCalcMora(1);
            c2.setNroCuota(i + 1);

            // CREAR LA FECHA DE VENCIMIENTO PARA CADA MES
            String mes2;
            if (cantMeses < 10) {
                mes2 = "0" + String.valueOf(cantMeses);
            } else {
                mes2 = String.valueOf(cantMeses);
            }
            String dia2 = "07";
            String fechaVencMes = dia2 + "/" + mes2 + "/" + anio2;
            String fechaVencMesDB = anio2 + "-" + mes2 + "-" + dia2;

            SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd/MM/yyyy");
            Date fecha = null;
            try {
                fecha = formatoDelTexto.parse(fechaVencMes);
            } catch (ParseException ex) {
                ex.printStackTrace();
            }

            System.out.println(fecha.toString());
            Calendar cal = Calendar.getInstance();
            cal.setTime(fecha);
            int diaDeSemana = cal.get(Calendar.DAY_OF_WEEK);
            System.out.println(diaDeSemana);

            // ---------------  NO HAY DIFERNECIA EN SI CAE DOMINGO O NO ------------------------
            diaDeSemana = 2;
            // ---------------  NO HAY DIFERNECIA EN SI CAE DOMINGO O NO ------------------------

            if (diaDeSemana == 1) {
                dia2 = "08";
                fechaVencMes = dia2 + "/" + mes2 + "/" + anio2;
                fechaVencMesDB = anio2 + "-" + mes2 + "-" + dia2;
            }

            cantMeses++;

            if (datosHermano.size() > 1) {
//*********************DESCUENTO POR HERMANO*******************
                for (DescuentoHermanoBean decHermano : datosHermano) {
                    if (decHermano.getCodAlumno() == codAlumno) {
                        //HERMANO ACTUAL O ALUMNO MATRICULANDO
                        c2.setDes_mot_cou(decHermano.getNomDesPension());
                        c2.setTot_cuo(montoPension - decHermano.getMontoDesPension());
                        if (decHermano.getTpmontoPension() == 1) {
                            c2.setDescuento_cuo(decHermano.getMontoDesPension());
                        } else {
                            c2.setDescuento_cuo(montoPension * (decHermano.getMontoDesPension()) / 100);
                        }
                    } else {
                        /// Cambio de pensiones alumnos o matricula
                    }
                }
            } else {
//*********************DESCUENTO NORMAL*******************
                c2.setTot_cuo(montoPension);
                c2.setDes_mot_cou(nombreDescuento);

                if (tipoMoneda == 1) {//monto en soles
                    c2.setDescuento_cuo(montDescuentoPension);
                } else { //monto en porcentaje 
                    c2.setDescuento_cuo(montoPension * ((montDescuentoPension) / 100));
                }
            }

// ************************************************************     
            c2.setTip_cuota(2);
            c2.setDes_cuota(meses[i]);
            c2.setFec_ven(fechaVencMesDB);
            c2.setMon_cuo(montoPension);
            listaCuotas.add(c2);
        }
        //*********************************** Registro CuotasPago***************************************

        for (CuotasPagoBean listaCuota : listaCuotas) {
            int ResultadoCuota = Serviocuota.registrarCuotaPago(listaCuota);
        }
        //*********************************** Registro CuotasPago*************************************** 

        //******************************Registro Documento del alumno**************************************
        RequisitoServices req = new RequisitoServices();
        for (int i = 0; i < codDocumento.length; i++) {
            req.registrarFichaRequisito(codMatricula, Integer.parseInt(codDocumento[i]));
        }
        //******************************Registro Documento del alumno**************************************
        JSONObject estado = new JSONObject("{estado:1}");
        pw.println(estado);
    }

    private void fichaMatriculaDatosAlumno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String codAlumno = request.getParameter("codAlumno");
        AlumnoServices servicio = new AlumnoServices();
        JSONArray jsonAlumno = new JSONArray(servicio.listaAlumno("4", codAlumno, "0", 0, 1));
        pw.println(jsonAlumno);
    }

    private void cuotasFichaMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codFichaMatricula = Integer.parseInt(request.getParameter("codFichaMatricula"));
        CuotasPagoServices service = new CuotasPagoServices();
        JSONArray cuotasFichaMatricula = new JSONArray(service.cuotasFichaMatricula(codFichaMatricula));
        pw.println(cuotasFichaMatricula);

    }

    private void actualizarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codMatricula = Integer.parseInt(request.getParameter("codMatricula"));
        int codAlumno = Integer.parseInt(request.getParameter("codAlumno"));
        int CodAula = Integer.parseInt(request.getParameter("CodAula"));
        int codDescuento = Integer.parseInt(request.getParameter("codDescuento"));
        String nombreDescuento = request.getParameter("nombreDescuento");

        double montoMatricula = Double.parseDouble(request.getParameter("montoMatricula"));
        double montoPension = Double.parseDouble(request.getParameter("montoPension"));

        double montDescuentoPension = Double.parseDouble(request.getParameter("montDescuentoPension"));
        double montDescuentoMatricula = Double.parseDouble(request.getParameter("montDescuentoMatricula"));
        int tipoMoneda;
        try {
            tipoMoneda = Integer.parseInt(request.getParameter("tipoMoneda"));
        } catch (Exception e) {
            tipoMoneda = 0;
        }

        String observacion = request.getParameter("observacion");
        int codInformes = Integer.parseInt(request.getParameter("codInformes"));
        int codColegioProc = Integer.parseInt(request.getParameter("codColegioProc"));
        int codUsuario = Integer.parseInt(request.getParameter("codUsuario"));
        String codDocumento[] = request.getParameter("codDocumento").split(",");
        int tipoMatricula = Integer.parseInt(request.getParameter("tipoMatricula"));
        int activarDescuento = Integer.parseInt(request.getParameter("activarDescuento"));
        String jsonHermano = request.getParameter("myJsonHermanos");
        
        
        
        MatriculaBean matricula = new MatriculaBean();
        matricula.setCodMatricula(codMatricula);
        matricula.setCodAlumno(codAlumno);
        matricula.setCodAula(CodAula);
//        matricula.setCodPeriodo(periodo.getCodPer());
        matricula.setCodDescuento(codDescuento);
        matricula.setNomDescuento(nombreDescuento);
        matricula.setMontoDescuentoMatricula(montDescuentoMatricula);
        if (tipoMoneda == 1) {
            matricula.setMontoDescuentoPension(montDescuentoPension);
        } else {
            matricula.setMontoDescuentoPension(montoPension * (montDescuentoPension / 100));
        }
        matricula.setObsMatricula(observacion);
        matricula.setCodInforma(codInformes);
        matricula.setCodColegioRef(codColegioProc);
        matricula.setCodUsuarioMatriculante(codUsuario);
        matricula.setTipoMatricula(tipoMatricula);
        
        
        MatriculaServices servicio=new MatriculaServices();
        int resultado=servicio.actualizarMatricula(matricula);
        JSONObject jsonResultado= new JSONObject("{estado:"+resultado+"}");
        pw.println(jsonResultado);
    }
}
