package pe.siso.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.json.JSONArray;
import org.json.JSONObject;
import pe.siso.beans.UbigeoBean;
import pe.siso.services.UbigeoServices;

public class UbigeoServlet extends HttpServlet {

 
    protected void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String param = request.getParameter("accionUbi");

        if ("listarDepartamentos".equals(param)) {
            listarDepartamentos(request, response);
        } else if ("listarProvincias".equals(param)) {
            listarProvincias(request, response);
        } else if ("listarDistritos".equals(param)) {
            listarDistritos(request, response);
        } else if ("consultarUbigeo".equals(param)) {
            consultarUbigeo(request,response);
        }
    }

    private void listarDepartamentos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        UbigeoServices servicios = new UbigeoServices();
        JSONArray JsonDepartamento = new JSONArray(servicios.listarDepartamentos());
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println(JsonDepartamento);
    }

    private void listarProvincias(HttpServletRequest request, HttpServletResponse response) throws IOException {
        UbigeoServices servicios = new UbigeoServices();
        String codigoDpto = request.getParameter("codigoDpto");
         JSONArray JsonProvincias =new JSONArray(servicios.listarProvincias(codigoDpto));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println(JsonProvincias);
    }

    private void listarDistritos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        UbigeoServices servicios = new UbigeoServices();
        String codigoDpto = request.getParameter("codigoDpto");
        String codigoProv = request.getParameter("codigoProv");
        JSONArray JsonDistritos=new JSONArray(servicios.listarDistritos(codigoDpto, codigoProv));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println(JsonDistritos);
    }

    private void consultarUbigeo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codUbigeo=Integer.parseInt(request.getParameter("codUbigeo"));
        UbigeoServices servicios = new UbigeoServices();
        JSONObject jsonConsultUbigeo=new JSONObject(servicios.consultarUbigeo(codUbigeo));
        pw.println(jsonConsultUbigeo);
    }
    

}
