/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.ws.WebServiceRef;
import org.apache.commons.codec.digest.DigestUtils;
import org.json.JSONArray;
import pe.siso.beans.LocalBean;
import pe.siso.seguridad.webservices.MenuBean;
import pe.siso.seguridad.webservices.MenuWebService_Service;
import pe.siso.seguridad.webservices.ProyectoBean;
import pe.siso.seguridad.webservices.ProyectoWebService_Service;
import pe.siso.seguridad.webservices.UsuarioBean;
import pe.siso.seguridad.webservices.UsuarioWebService_Service;
import pe.siso.services.LocalServices;

/**
 *
 * @author sistem05user
 */
public class UsuarioServlet extends HttpServlet {

    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/app8.sacooliveros.edu.pe_8080/Seguridad/ProyectoWebService.wsdl")
    private ProyectoWebService_Service service_2;

    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/app8.sacooliveros.edu.pe_8080/Seguridad/MenuWebService.wsdl")
    private MenuWebService_Service service_1;

    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/app8.sacooliveros.edu.pe_8080/Seguridad/UsuarioWebService.wsdl")
    private UsuarioWebService_Service service;

    protected void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String param = request.getParameter("Accion");

        if ("validarUsuario".equals(param)) {
            validarUsuario(request, response);
        } else if ("redireccion".equals(param)) {
            redireccion(request, response);
        } else if ("redireccionUsuario".equals(param)) {
            redireccionUsuario(request, response);
        }

    }

    private void validarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int dato = 0;
        String txtUsuario = request.getParameter("txtUsuario");
        String txtContrasena = request.getParameter("txtContrasena");

        String passwordEncriptado = DigestUtils.md5Hex(txtContrasena);

        //UsuarioServices servicios = new UsuarioServices();
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();

        int proyecto = 6;/*Sistema de gestion logistica*/

        //dato = servicios.validarUsuario(txtUsuario, txtContrasena);

        dato = validarUsuarioWebservice(txtUsuario, passwordEncriptado, proyecto);

        if (dato == 0) {
            pw.println("0");
        } else {
            HttpSession session_actual = request.getSession(true);
            UsuarioBean usuario = consultarDatosWebservice(txtUsuario, passwordEncriptado, proyecto);

            int codigoProyectoDetalle = usuario.getCodigoProyectoDetalle();

            List<ProyectoBean> listaProyectos = listarProyectoUsuario(usuario.getCodigoUsuario());
            session_actual.setAttribute("listaProyectos", listaProyectos);

            List<MenuBean> menuTitulo = listarTituloWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionTitulo", menuTitulo);

            List<MenuBean> menuModulo = listarModuloWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionModulo", menuModulo);

            List<MenuBean> menuCategoria = listarCategoriaWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionCategoria", menuCategoria);

            List<MenuBean> menuSubCategoria = listarSubCategoriaWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionSubCategoria", menuSubCategoria);
            ArrayList<LocalBean> lista = new ArrayList<>();
            LocalServices servicio = new LocalServices();

            lista = servicio.localSistema(usuario.getCodigoProyectoDetalle(), usuario.getCodigoSede());

            JSONArray jsonLocal = new JSONArray(lista);
            session_actual.setAttribute("jsonLocal", jsonLocal);
            session_actual.setAttribute("usuario", usuario);

            session_actual.setMaxInactiveInterval(10 * 60 * 60);// 10 horas
            pw.println("1");

        }
    }

    private void redireccion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        HttpSession session_actual = request.getSession(true);
        UsuarioBean usuarioSession = (UsuarioBean) session_actual.getAttribute("usuario");
        String usuario = usuarioSession.getUsuario();
        String clave = usuarioSession.getContrasena();

        int p = Integer.parseInt(request.getParameter("p"));

        ProyectoBean proyecto = consultarProyecto(p);
        response.sendRedirect(proyecto.getUrlProyecto() + "UsuarioServlet?Accion=redireccionUsuario&usuario=" + usuario + "&clave=" + clave + "");
    }

    private void redireccionUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {

        int valor = 0;
        String dato = "";

        String usuario = request.getParameter("txtUsuario");
        String passwordEncriptado = request.getParameter("txtContrasena");
        int proyecto = 5;

        valor = validarUsuarioWebservice(usuario, passwordEncriptado, proyecto);
        PrintWriter pw = response.getWriter();

        if (valor == 0) {
            response.sendRedirect("vista/index.jsp");
            //pw.println("0");
        } else {
            HttpSession session_actual = request.getSession(true);
            UsuarioBean usu = consultarDatosWebservice(usuario, passwordEncriptado, proyecto);

            int codigoProyectoDetalle = usu.getCodigoProyectoDetalle();

            List<ProyectoBean> listaProyectos = listarProyectoUsuario(usu.getCodigoUsuario());
            session_actual.setAttribute("listaProyectos", listaProyectos);

            List<MenuBean> menuTitulo = listarTituloWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionTitulo", menuTitulo);

            List<MenuBean> menuModulo = listarModuloWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionModulo", menuModulo);

            List<MenuBean> menuCategoria = listarCategoriaWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionCategoria", menuCategoria);

            List<MenuBean> menuSubCategoria = listarSubCategoriaWebservice(codigoProyectoDetalle);
            session_actual.setAttribute("menuSesionSubCategoria", menuSubCategoria);

            session_actual.setAttribute("usuario", usu);
            session_actual.setMaxInactiveInterval(10 * 60 * 60);// 10 horas

        }
    }

    private Integer validarUsuarioWebservice(java.lang.String usuario, java.lang.String clave, int proyecto) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.UsuarioWebService port = service.getUsuarioWebServicePort();
        return port.validarUsuarioWebservice(usuario, clave, proyecto);
    }

    private UsuarioBean consultarDatosWebservice(java.lang.String usuario, java.lang.String clave, int proyecto) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.UsuarioWebService port = service.getUsuarioWebServicePort();
        return port.consultarDatosWebservice(usuario, clave, proyecto);
    }

    private java.util.List<pe.siso.seguridad.webservices.MenuBean> listarCategoriaWebservice(int codigoProyectoDetalle) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.MenuWebService port = service_1.getMenuWebServicePort();
        return port.listarCategoriaWebservice(codigoProyectoDetalle);
    }

    private java.util.List<pe.siso.seguridad.webservices.MenuBean> listarModuloWebservice(int codigoProyectoDetalle) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.MenuWebService port = service_1.getMenuWebServicePort();
        return port.listarModuloWebservice(codigoProyectoDetalle);
    }

    private java.util.List<pe.siso.seguridad.webservices.MenuBean> listarSubCategoriaWebservice(int codigoProyectoDetalle) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.MenuWebService port = service_1.getMenuWebServicePort();
        return port.listarSubCategoriaWebservice(codigoProyectoDetalle);
    }

    private java.util.List<pe.siso.seguridad.webservices.MenuBean> listarTituloWebservice(int codigoProyectoDetalle) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.MenuWebService port = service_1.getMenuWebServicePort();
        return port.listarTituloWebservice(codigoProyectoDetalle);
    }

    private ProyectoBean consultarProyecto(java.lang.Integer name) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.ProyectoWebService port = service_2.getProyectoWebServicePort();
        return port.consultarProyecto(name);
    }

    private java.util.List<pe.siso.seguridad.webservices.ProyectoBean> listarProyectoUsuario(int codigoUsuario) {
        // Note that the injected javax.xml.ws.Service reference as well as port objects are not thread safe.
        // If the calling of port operations may lead to race condition some synchronization is required.
        pe.siso.seguridad.webservices.ProyectoWebService port = service_2.getProyectoWebServicePort();
        return port.listarProyectoUsuario(codigoUsuario);
    }

}
